# -*- coding: binary -*-

module Msf::Post::Windows::Error
  SUCCESS = 0x0000
  INVALID_FUNCTION = 0x0001
  FILE_NOT_FOUND = 0x0002
  PATH_NOT_FOUND = 0x0003
  TOO_MANY_OPEN_FILES = 0x0004
  ACCESS_DENIED = 0x0005
  INVALID_HANDLE = 0x0006
  ARENA_TRASHED = 0x0007
  NOT_ENOUGH_MEMORY = 0x0008
  INVALID_BLOCK = 0x0009
  BAD_ENVIRONMENT = 0x000A
  BAD_FORMAT = 0x000B
  INVALID_ACCESS = 0x000C
  INVALID_DATA = 0x000D
  OUTOFMEMORY = 0x000E
  INVALID_DRIVE = 0x000F
  CURRENT_DIRECTORY = 0x0010
  NOT_SAME_DEVICE = 0x0011
  NO_MORE_FILES = 0x0012
  WRITE_PROTECT = 0x0013
  BAD_UNIT = 0x0014
  NOT_READY = 0x0015
  BAD_COMMAND = 0x0016
  CRC = 0x0017
  BAD_LENGTH = 0x0018
  SEEK = 0x0019
  NOT_DOS_DISK = 0x001A
  SECTOR_NOT_FOUND = 0x001B
  OUT_OF_PAPER = 0x001C
  WRITE_FAULT = 0x001D
  READ_FAULT = 0x001E
  GEN_FAILURE = 0x001F
  SHARING_VIOLATION = 0x0020
  LOCK_VIOLATION = 0x0021
  WRONG_DISK = 0x0022
  SHARING_BUFFER_EXCEEDED = 0x0024
  HANDLE_EOF = 0x0026
  HANDLE_DISK_FULL = 0x0027
  NOT_SUPPORTED = 0x0032
  REM_NOT_LIST = 0x0033
  DUP_NAME = 0x0034
  BAD_NETPATH = 0x0035
  NETWORK_BUSY = 0x0036
  DEV_NOT_EXIST = 0x0037
  TOO_MANY_CMDS = 0x0038
  ADAP_HDW_ERR = 0x0039
  BAD_NET_RESP = 0x003A
  UNEXP_NET_ERR = 0x003B
  BAD_REM_ADAP = 0x003C
  PRINTQ_FULL = 0x003D
  NO_SPOOL_SPACE = 0x003E
  PRINT_CANCELLED = 0x003F
  NETNAME_DELETED = 0x0040
  NETWORK_ACCESS_DENIED = 0x0041
  BAD_DEV_TYPE = 0x0042
  BAD_NET_NAME = 0x0043
  TOO_MANY_NAMES = 0x0044
  TOO_MANY_SESS = 0x0045
  SHARING_PAUSED = 0x0046
  REQ_NOT_ACCEP = 0x0047
  REDIR_PAUSED = 0x0048
  FILE_EXISTS = 0x0050
  CANNOT_MAKE = 0x0052
  FAIL_I24 = 0x0053
  OUT_OF_STRUCTURES = 0x0054
  ALREADY_ASSIGNED = 0x0055
  INVALID_PASSWORD = 0x0056
  INVALID_PARAMETER = 0x0057
  NET_WRITE_FAULT = 0x0058
  NO_PROC_SLOTS = 0x0059
  TOO_MANY_SEMAPHORES = 0x0064
  EXCL_SEM_ALREADY_OWNED = 0x0065
  SEM_IS_SET = 0x0066
  TOO_MANY_SEM_REQUESTS = 0x0067
  INVALID_AT_INTERRUPT_TIME = 0x0068
  SEM_OWNER_DIED = 0x0069
  SEM_USER_LIMIT = 0x006A
  DISK_CHANGE = 0x006B
  DRIVE_LOCKED = 0x006C
  BROKEN_PIPE = 0x006D
  OPEN_FAILED = 0x006E
  BUFFER_OVERFLOW = 0x006F
  DISK_FULL = 0x0070
  NO_MORE_SEARCH_HANDLES = 0x0071
  INVALID_TARGET_HANDLE = 0x0072
  INVALID_CATEGORY = 0x0075
  INVALID_VERIFY_SWITCH = 0x0076
  BAD_DRIVER_LEVEL = 0x0077
  CALL_NOT_IMPLEMENTED = 0x0078
  SEM_TIMEOUT = 0x0079
  INSUFFICIENT_BUFFER = 0x007A
  INVALID_NAME = 0x007B
  INVALID_LEVEL = 0x007C
  NO_VOLUME_LABEL = 0x007D
  MOD_NOT_FOUND = 0x007E
  PROC_NOT_FOUND = 0x007F
  WAIT_NO_CHILDREN = 0x0080
  CHILD_NOT_COMPLETE = 0x0081
  DIRECT_ACCESS_HANDLE = 0x0082
  NEGATIVE_SEEK = 0x0083
  SEEK_ON_DEVICE = 0x0084
  IS_JOIN_TARGET = 0x0085
  IS_JOINED = 0x0086
  IS_SUBSTED = 0x0087
  NOT_JOINED = 0x0088
  NOT_SUBSTED = 0x0089
  JOIN_TO_JOIN = 0x008A
  SUBST_TO_SUBST = 0x008B
  JOIN_TO_SUBST = 0x008C
  SUBST_TO_JOIN = 0x008D
  BUSY_DRIVE = 0x008E
  SAME_DRIVE = 0x008F
  DIR_NOT_ROOT = 0x0090
  DIR_NOT_EMPTY = 0x0091
  IS_SUBST_PATH = 0x0092
  IS_JOIN_PATH = 0x0093
  PATH_BUSY = 0x0094
  IS_SUBST_TARGET = 0x0095
  SYSTEM_TRACE = 0x0096
  INVALID_EVENT_COUNT = 0x0097
  TOO_MANY_MUXWAITERS = 0x0098
  INVALID_LIST_FORMAT = 0x0099
  LABEL_TOO_LONG = 0x009A
  TOO_MANY_TCBS = 0x009B
  SIGNAL_REFUSED = 0x009C
  DISCARDED = 0x009D
  NOT_LOCKED = 0x009E
  BAD_THREADID_ADDR = 0x009F
  BAD_ARGUMENTS = 0x00A0
  BAD_PATHNAME = 0x00A1
  SIGNAL_PENDING = 0x00A2
  MAX_THRDS_REACHED = 0x00A4
  LOCK_FAILED = 0x00A7
  BUSY = 0x00AA
  CANCEL_VIOLATION = 0x00AD
  ATOMIC_LOCKS_NOT_SUPPORTED = 0x00AE
  INVALID_SEGMENT_NUMBER = 0x00B4
  INVALID_ORDINAL = 0x00B6
  ALREADY_EXISTS = 0x00B7
  INVALID_FLAG_NUMBER = 0x00BA
  SEM_NOT_FOUND = 0x00BB
  INVALID_STARTING_CODESEG = 0x00BC
  INVALID_STACKSEG = 0x00BD
  INVALID_MODULETYPE = 0x00BE
  INVALID_EXE_SIGNATURE = 0x00BF
  EXE_MARKED_INVALID = 0x00C0
  BAD_EXE_FORMAT = 0x00C1
  ITERATED_DATA_EXCEEDS_64k = 0x00C2
  INVALID_MINALLOCSIZE = 0x00C3
  DYNLINK_FROM_INVALID_RING = 0x00C4
  IOPL_NOT_ENABLED = 0x00C5
  INVALID_SEGDPL = 0x00C6
  AUTODATASEG_EXCEEDS_64k = 0x00C7
  RING2SEG_MUST_BE_MOVABLE = 0x00C8
  RELOC_CHAIN_XEEDS_SEGLIM = 0x00C9
  INFLOOP_IN_RELOC_CHAIN = 0x00CA
  ENVVAR_NOT_FOUND = 0x00CB
  NO_SIGNAL_SENT = 0x00CD
  FILENAME_EXCED_RANGE = 0x00CE
  RING2_STACK_IN_USE = 0x00CF
  META_EXPANSION_TOO_LONG = 0x00D0
  INVALID_SIGNAL_NUMBER = 0x00D1
  THREAD_1_INACTIVE = 0x00D2
  LOCKED = 0x00D4
  TOO_MANY_MODULES = 0x00D6
  NESTING_NOT_ALLOWED = 0x00D7
  EXE_MACHINE_TYPE_MISMATCH = 0x00D8
  EXE_CANNOT_MODIFY_SIGNED_BINARY = 0x00D9
  EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY = 0x00DA
  FILE_CHECKED_OUT = 0x00DC
  CHECKOUT_REQUIRED = 0x00DD
  BAD_FILE_TYPE = 0x00DE
  FILE_TOO_LARGE = 0x00DF
  FORMS_AUTH_REQUIRED = 0x00E0
  VIRUS_INFECTED = 0x00E1
  VIRUS_DELETED = 0x00E2
  PIPE_LOCAL = 0x00E5
  BAD_PIPE = 0x00E6
  PIPE_BUSY = 0x00E7
  NO_DATA = 0x00E8
  PIPE_NOT_CONNECTED = 0x00E9
  MORE_DATA = 0x00EA
  VC_DISCONNECTED = 0x00F0
  INVALID_EA_NAME = 0x00FE
  EA_LIST_INCONSISTENT = 0x00FF
  WAIT_TIMEOUT = 0x0102
  NO_MORE_ITEMS = 0x0103
  CANNOT_COPY = 0x010A
  DIRECTORY = 0x010B
  EAS_DIDNT_FIT = 0x0113
  EA_FILE_CORRUPT = 0x0114
  EA_TABLE_FULL = 0x0115
  INVALID_EA_HANDLE = 0x0116
  EAS_NOT_SUPPORTED = 0x011A
  NOT_OWNER = 0x0120
  TOO_MANY_POSTS = 0x012A
  PARTIAL_COPY = 0x012B
  OPLOCK_NOT_GRANTED = 0x012C
  INVALID_OPLOCK_PROTOCOL = 0x012D
  DISK_TOO_FRAGMENTED = 0x012E
  DELETE_PENDING = 0x012F
  INCOMPATIBLE_WITH_GLOBAL_SHORT_NAME_REGISTRY_SETTING = 0x0130
  SHORT_NAMES_NOT_ENABLED_ON_VOLUME = 0x0131
  SECURITY_STREAM_IS_INCONSISTENT = 0x0132
  INVALID_LOCK_RANGE = 0x0133
  IMAGE_SUBSYSTEM_NOT_PRESENT = 0x0134
  NOTIFICATION_GUID_ALREADY_DEFINED = 0x0135
  MR_MID_NOT_FOUND = 0x013D
  SCOPE_NOT_FOUND = 0x013E
  FAIL_NOACTION_REBOOT = 0x015E
  FAIL_SHUTDOWN = 0x015F
  FAIL_RESTART = 0x0160
  MAX_SESSIONS_REACHED = 0x0161
  THREAD_MODE_ALREADY_BACKGROUND = 0x0190
  THREAD_MODE_NOT_BACKGROUND = 0x0191
  PROCESS_MODE_ALREADY_BACKGROUND = 0x0192
  PROCESS_MODE_NOT_BACKGROUND = 0x0193
  INVALID_ADDRESS = 0x01E7
  USER_PROFILE_LOAD = 0x01F4
  ARITHMETIC_OVERFLOW = 0x0216
  PIPE_CONNECTED = 0x0217
  PIPE_LISTENING = 0x0218
  VERIFIER_STOP = 0x0219
  ABIOS_ERROR = 0x021A
  WX86_WARNING = 0x021B
  WX86_ERROR = 0x021C
  TIMER_NOT_CANCELED = 0x021D
  UNWIND = 0x021E
  BAD_STACK = 0x021F
  INVALID_UNWIND_TARGET = 0x0220
  INVALID_PORT_ATTRIBUTES = 0x0221
  PORT_MESSAGE_TOO_LONG = 0x0222
  INVALID_QUOTA_LOWER = 0x0223
  DEVICE_ALREADY_ATTACHED = 0x0224
  INSTRUCTION_MISALIGNMENT = 0x0225
  PROFILING_NOT_STARTED = 0x0226
  PROFILING_NOT_STOPPED = 0x0227
  COULD_NOT_INTERPRET = 0x0228
  PROFILING_AT_LIMIT = 0x0229
  CANT_WAIT = 0x022A
  CANT_TERMINATE_SELF = 0x022B
  UNEXPECTED_MM_CREATE_ERR = 0x022C
  UNEXPECTED_MM_MAP_ERROR = 0x022D
  UNEXPECTED_MM_EXTEND_ERR = 0x022E
  BAD_FUNCTION_TABLE = 0x022F
  NO_GUID_TRANSLATION = 0x0230
  INVALID_LDT_SIZE = 0x0231
  INVALID_LDT_OFFSET = 0x0233
  INVALID_LDT_DESCRIPTOR = 0x0234
  TOO_MANY_THREADS = 0x0235
  THREAD_NOT_IN_PROCESS = 0x0236
  PAGEFILE_QUOTA_EXCEEDED = 0x0237
  LOGON_SERVER_CONFLICT = 0x0238
  SYNCHRONIZATION_REQUIRED = 0x0239
  NET_OPEN_FAILED = 0x023A
  IO_PRIVILEGE_FAILED = 0x023B
  CONTROL_C_EXIT = 0x023C
  MISSING_SYSTEMFILE = 0x023D
  UNHANDLED_EXCEPTION = 0x023E
  APP_INIT_FAILURE = 0x023F
  PAGEFILE_CREATE_FAILED = 0x0240
  INVALID_IMAGE_HASH = 0x0241
  NO_PAGEFILE = 0x0242
  ILLEGAL_FLOAT_CONTEXT = 0x0243
  NO_EVENT_PAIR = 0x0244
  DOMAIN_CTRLR_CONFIG_ERROR = 0x0245
  ILLEGAL_CHARACTER = 0x0246
  UNDEFINED_CHARACTER = 0x0247
  FLOPPY_VOLUME = 0x0248
  BIOS_FAILED_TO_CONNECT_INTERRUPT = 0x0249
  BACKUP_CONTROLLER = 0x024A
  MUTANT_LIMIT_EXCEEDED = 0x024B
  FS_DRIVER_REQUIRED = 0x024C
  CANNOT_LOAD_REGISTRY_FILE = 0x024D
  DEBUG_ATTACH_FAILED = 0x024E
  SYSTEM_PROCESS_TERMINATED = 0x024F
  DATA_NOT_ACCEPTED = 0x0250
  VDM_HARD_ERROR = 0x0251
  DRIVER_CANCEL_TIMEOUT = 0x0252
  REPLY_MESSAGE_MISMATCH = 0x0253
  LOST_WRITEBEHIND_DATA = 0x0254
  CLIENT_SERVER_PARAMETERS_INVALID = 0x0255
  NOT_TINY_STREAM = 0x0256
  STACK_OVERFLOW_READ = 0x0257
  CONVERT_TO_LARGE = 0x0258
  FOUND_OUT_OF_SCOPE = 0x0259
  ALLOCATE_BUCKET = 0x025A
  MARSHALL_OVERFLOW = 0x025B
  INVALID_VARIANT = 0x025C
  BAD_COMPRESSION_BUFFER = 0x025D
  AUDIT_FAILED = 0x025E
  TIMER_RESOLUTION_NOT_SET = 0x025F
  INSUFFICIENT_LOGON_INFO = 0x0260
  BAD_DLL_ENTRYPOINT = 0x0261
  BAD_SERVICE_ENTRYPOINT = 0x0262
  IP_ADDRESS_CONFLICT1 = 0x0263
  IP_ADDRESS_CONFLICT2 = 0x0264
  REGISTRY_QUOTA_LIMIT = 0x0265
  NO_CALLBACK_ACTIVE = 0x0266
  PWD_TOO_SHORT = 0x0267
  PWD_TOO_RECENT = 0x0268
  PWD_HISTORY_CONFLICT = 0x0269
  UNSUPPORTED_COMPRESSION = 0x026A
  INVALID_HW_PROFILE = 0x026B
  INVALID_PLUGPLAY_DEVICE_PATH = 0x026C
  QUOTA_LIST_INCONSISTENT = 0x026D
  EVALUATION_EXPIRATION = 0x026E
  ILLEGAL_DLL_RELOCATION = 0x026F
  DLL_INIT_FAILED_LOGOFF = 0x0270
  VALIDATE_CONTINUE = 0x0271
  NO_MORE_MATCHES = 0x0272
  RANGE_LIST_CONFLICT = 0x0273
  SERVER_SID_MISMATCH = 0x0274
  CANT_ENABLE_DENY_ONLY = 0x0275
  FLOAT_MULTIPLE_FAULTS = 0x0276
  FLOAT_MULTIPLE_TRAPS = 0x0277
  NOINTERFACE = 0x0278
  DRIVER_FAILED_SLEEP = 0x0279
  CORRUPT_SYSTEM_FILE = 0x027A
  COMMITMENT_MINIMUM = 0x027B
  PNP_RESTART_ENUMERATION = 0x027C
  SYSTEM_IMAGE_BAD_SIGNATURE = 0x027D
  PNP_REBOOT_REQUIRED = 0x027E
  INSUFFICIENT_POWER = 0x027F
  MULTIPLE_FAULT_VIOLATION = 0x0280
  SYSTEM_SHUTDOWN = 0x0281
  PORT_NOT_SET = 0x0282
  DS_VERSION_CHECK_FAILURE = 0x0283
  RANGE_NOT_FOUND = 0x0284
  NOT_SAFE_MODE_DRIVER = 0x0286
  FAILED_DRIVER_ENTRY = 0x0287
  DEVICE_ENUMERATION_ERROR = 0x0288
  MOUNT_POINT_NOT_RESOLVED = 0x0289
  INVALID_DEVICE_OBJECT_PARAMETER = 0x028A
  MCA_OCCURED = 0x028B
  DRIVER_DATABASE_ERROR = 0x028C
  SYSTEM_HIVE_TOO_LARGE = 0x028D
  DRIVER_FAILED_PRIOR_UNLOAD = 0x028E
  VOLSNAP_PREPARE_HIBERNATE = 0x028F
  HIBERNATION_FAILURE = 0x0290
  FILE_SYSTEM_LIMITATION = 0x0299
  ASSERTION_FAILURE = 0x029C
  ACPI_ERROR = 0x029D
  WOW_ASSERTION = 0x029E
  PNP_BAD_MPS_TABLE = 0x029F
  PNP_TRANSLATION_FAILED = 0x02A0
  PNP_IRQ_TRANSLATION_FAILED = 0x02A1
  PNP_INVALID_ID = 0x02A2
  WAKE_SYSTEM_DEBUGGER = 0x02A3
  HANDLES_CLOSED = 0x02A4
  EXTRANEOUS_INFORMATION = 0x02A5
  RXACT_COMMIT_NECESSARY = 0x02A6
  MEDIA_CHECK = 0x02A7
  GUID_SUBSTITUTION_MADE = 0x02A8
  STOPPED_ON_SYMLINK = 0x02A9
  LONGJUMP = 0x02AA
  PLUGPLAY_QUERY_VETOED = 0x02AB
  UNWIND_CONSOLIDATE = 0x02AC
  REGISTRY_HIVE_RECOVERED = 0x02AD
  DLL_MIGHT_BE_INSECURE = 0x02AE
  DLL_MIGHT_BE_INCOMPATIBLE = 0x02AF
  DBG_EXCEPTION_NOT_HANDLED = 0x02B0
  DBG_REPLY_LATER = 0x02B1
  DBG_UNABLE_TO_PROVIDE_HANDLE = 0x02B2
  DBG_TERMINATE_THREAD = 0x02B3
  DBG_TERMINATE_PROCESS = 0x02B4
  DBG_CONTROL_C = 0x02B5
  DBG_PRINTEXCEPTION_C = 0x02B6
  DBG_RIPEXCEPTION = 0x02B7
  DBG_CONTROL_BREAK = 0x02B8
  DBG_COMMAND_EXCEPTION = 0x02B9
  OBJECT_NAME_EXISTS = 0x02BA
  THREAD_WAS_SUSPENDED = 0x02BB
  IMAGE_NOT_AT_BASE = 0x02BC
  RXACT_STATE_CREATED = 0x02BD
  SEGMENT_NOTIFICATION = 0x02BE
  BAD_CURRENT_DIRECTORY = 0x02BF
  FT_READ_RECOVERY_FROM_BACKUP = 0x02C0
  FT_WRITE_RECOVERY = 0x02C1
  IMAGE_MACHINE_TYPE_MISMATCH = 0x02C2
  RECEIVE_PARTIAL = 0x02C3
  RECEIVE_EXPEDITED = 0x02C4
  RECEIVE_PARTIAL_EXPEDITED = 0x02C5
  EVENT_DONE = 0x02C6
  EVENT_PENDING = 0x02C7
  CHECKING_FILE_SYSTEM = 0x02C8
  FATAL_APP_EXIT = 0x02C9
  PREDEFINED_HANDLE = 0x02CA
  WAS_UNLOCKED = 0x02CB
  SERVICE_NOTIFICATION = 0x02CC
  WAS_LOCKED = 0x02CD
  LOG_HARD_ERROR = 0x02CE
  ALREADY_WIN32 = 0x02CF
  IMAGE_MACHINE_TYPE_MISMATCH_EXE = 0x02D0
  NO_YIELD_PERFORMED = 0x02D1
  TIMER_RESUME_IGNORED = 0x02D2
  ARBITRATION_UNHANDLED = 0x02D3
  CARDBUS_NOT_SUPPORTED = 0x02D4
  MP_PROCESSOR_MISMATCH = 0x02D5
  HIBERNATED = 0x02D6
  RESUME_HIBERNATION = 0x02D7
  FIRMWARE_UPDATED = 0x02D8
  DRIVERS_LEAKING_LOCKED_PAGES = 0x02D9
  WAKE_SYSTEM = 0x02DA
  WAIT_1 = 0x02DB
  WAIT_2 = 0x02DC
  WAIT_3 = 0x02DD
  WAIT_63 = 0x02DE
  ABANDONED_WAIT_0 = 0x02DF
  ABANDONED_WAIT_63 = 0x02E0
  USER_APC = 0x02E1
  KERNEL_APC = 0x02E2
  ALERTED = 0x02E3
  ELEVATION_REQUIRED = 0x02E4
  REPARSE = 0x02E5
  OPLOCK_BREAK_IN_PROGRESS = 0x02E6
  VOLUME_MOUNTED = 0x02E7
  RXACT_COMMITTED = 0x02E8
  NOTIFY_CLEANUP = 0x02E9
  PRIMARY_TRANSPORT_CONNECT_FAILED = 0x02EA
  PAGE_FAULT_TRANSITION = 0x02EB
  PAGE_FAULT_DEMAND_ZERO = 0x02EC
  PAGE_FAULT_COPY_ON_WRITE = 0x02ED
  PAGE_FAULT_GUARD_PAGE = 0x02EE
  PAGE_FAULT_PAGING_FILE = 0x02EF
  CACHE_PAGE_LOCKED = 0x02F0
  CRASH_DUMP = 0x02F1
  BUFFER_ALL_ZEROS = 0x02F2
  REPARSE_OBJECT = 0x02F3
  RESOURCE_REQUIREMENTS_CHANGED = 0x02F4
  TRANSLATION_COMPLETE = 0x02F5
  NOTHING_TO_TERMINATE = 0x02F6
  PROCESS_NOT_IN_JOB = 0x02F7
  PROCESS_IN_JOB = 0x02F8
  VOLSNAP_HIBERNATE_READY = 0x02F9
  FSFILTER_OP_COMPLETED_SUCCESSFULLY = 0x02FA
  INTERRUPT_VECTOR_ALREADY_CONNECTED = 0x02FB
  INTERRUPT_STILL_CONNECTED = 0x02FC
  WAIT_FOR_OPLOCK = 0x02FD
  DBG_EXCEPTION_HANDLED = 0x02FE
  DBG_CONTINUE = 0x02FF
  CALLBACK_POP_STACK = 0x0300
  COMPRESSION_DISABLED = 0x0301
  CANTFETCHBACKWARDS = 0x0302
  CANTSCROLLBACKWARDS = 0x0303
  ROWSNOTRELEASED = 0x0304
  BAD_ACCESSOR_FLAGS = 0x0305
  ERRORS_ENCOUNTERED = 0x0306
  NOT_CAPABLE = 0x0307
  REQUEST_OUT_OF_SEQUENCE = 0x0308
  VERSION_PARSE_ERROR = 0x0309
  BADSTARTPOSITION = 0x030A
  MEMORY_HARDWARE = 0x030B
  DISK_REPAIR_DISABLED = 0x030C
  INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE = 0x030D
  SYSTEM_POWERSTATE_TRANSITION = 0x030E
  SYSTEM_POWERSTATE_COMPLEX_TRANSITION = 0x030F
  MCA_EXCEPTION = 0x0310
  ACCESS_AUDIT_BY_POLICY = 0x0311
  ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY = 0x0312
  ABANDON_HIBERFILE = 0x0313
  LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED = 0x0314
  LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR = 0x0315
  LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR = 0x0316
  BAD_MCFG_TABLE = 0x0317
  OPLOCK_SWITCHED_TO_NEW_HANDLE = 0x0320
  CANNOT_GRANT_REQUESTED_OPLOCK = 0x0321
  CANNOT_BREAK_OPLOCK = 0x0322
  OPLOCK_HANDLE_CLOSED = 0x0323
  NO_ACE_CONDITION = 0x0324
  INVALID_ACE_CONDITION = 0x0325
  EA_ACCESS_DENIED = 0x03E2
  OPERATION_ABORTED = 0x03E3
  IO_INCOMPLETE = 0x03E4
  IO_PENDING = 0x03E5
  NOACCESS = 0x03E6
  SWAPERROR = 0x03E7
  STACK_OVERFLOW = 0x03E9
  INVALID_MESSAGE = 0x03EA
  CAN_NOT_COMPLETE = 0x03EB
  INVALID_FLAGS = 0x03EC
  UNRECOGNIZED_VOLUME = 0x03ED
  FILE_INVALID = 0x03EE
  FULLSCREEN_MODE = 0x03EF
  NO_TOKEN = 0x03F0
  BADDB = 0x03F1
  BADKEY = 0x03F2
  CANTOPEN = 0x03F3
  CANTREAD = 0x03F4
  CANTWRITE = 0x03F5
  REGISTRY_RECOVERED = 0x03F6
  REGISTRY_CORRUPT = 0x03F7
  REGISTRY_IO_FAILED = 0x03F8
  NOT_REGISTRY_FILE = 0x03F9
  KEY_DELETED = 0x03FA
  NO_LOG_SPACE = 0x03FB
  KEY_HAS_CHILDREN = 0x03FC
  CHILD_MUST_BE_VOLATILE = 0x03FD
  NOTIFY_ENUM_DIR = 0x03FE
  DEPENDENT_SERVICES_RUNNING = 0x041B
  INVALID_SERVICE_CONTROL = 0x041C
  SERVICE_REQUEST_TIMEOUT = 0x041D
  SERVICE_NO_THREAD = 0x041E
  SERVICE_DATABASE_LOCKED = 0x041F
  SERVICE_ALREADY_RUNNING = 0x0420
  INVALID_SERVICE_ACCOUNT = 0x0421
  SERVICE_DISABLED = 0x0422
  CIRCULAR_DEPENDENCY = 0x0423
  SERVICE_DOES_NOT_EXIST = 0x0424
  SERVICE_CANNOT_ACCEPT_CTRL = 0x0425
  SERVICE_NOT_ACTIVE = 0x0426
  FAILED_SERVICE_CONTROLLER_CONNECT = 0x0427
  EXCEPTION_IN_SERVICE = 0x0428
  DATABASE_DOES_NOT_EXIST = 0x0429
  SERVICE_SPECIFIC_ERROR = 0x042A
  PROCESS_ABORTED = 0x042B
  SERVICE_DEPENDENCY_FAIL = 0x042C
  SERVICE_LOGON_FAILED = 0x042D
  SERVICE_START_HANG = 0x042E
  INVALID_SERVICE_LOCK = 0x042F
  SERVICE_MARKED_FOR_DELETE = 0x0430
  SERVICE_EXISTS = 0x0431
  ALREADY_RUNNING_LKG = 0x0432
  SERVICE_DEPENDENCY_DELETED = 0x0433
  BOOT_ALREADY_ACCEPTED = 0x0434
  SERVICE_NEVER_STARTED = 0x0435
  DUPLICATE_SERVICE_NAME = 0x0436
  DIFFERENT_SERVICE_ACCOUNT = 0x0437
  CANNOT_DETECT_DRIVER_FAILURE = 0x0438
  CANNOT_DETECT_PROCESS_ABORT = 0x0439
  NO_RECOVERY_PROGRAM = 0x043A
  SERVICE_NOT_IN_EXE = 0x043B
  NOT_SAFEBOOT_SERVICE = 0x043C
  END_OF_MEDIA = 0x044C
  FILEMARK_DETECTED = 0x044D
  BEGINNING_OF_MEDIA = 0x044E
  SETMARK_DETECTED = 0x044F
  NO_DATA_DETECTED = 0x0450
  PARTITION_FAILURE = 0x0451
  INVALID_BLOCK_LENGTH = 0x0452
  DEVICE_NOT_PARTITIONED = 0x0453
  UNABLE_TO_LOCK_MEDIA = 0x0454
  UNABLE_TO_UNLOAD_MEDIA = 0x0455
  MEDIA_CHANGED = 0x0456
  BUS_RESET = 0x0457
  NO_MEDIA_IN_DRIVE = 0x0458
  NO_UNICODE_TRANSLATION = 0x0459
  DLL_INIT_FAILED = 0x045A
  SHUTDOWN_IN_PROGRESS = 0x045B
  NO_SHUTDOWN_IN_PROGRESS = 0x045C
  IO_DEVICE = 0x045D
  SERIAL_NO_DEVICE = 0x045E
  IRQ_BUSY = 0x045F
  MORE_WRITES = 0x0460
  COUNTER_TIMEOUT = 0x0461
  FLOPPY_ID_MARK_NOT_FOUND = 0x0462
  FLOPPY_WRONG_CYLINDER = 0x0463
  FLOPPY_UNKNOWN_ERROR = 0x0464
  FLOPPY_BAD_REGISTERS = 0x0465
  DISK_RECALIBRATE_FAILED = 0x0466
  DISK_OPERATION_FAILED = 0x0467
  DISK_RESET_FAILED = 0x0468
  EOM_OVERFLOW = 0x0469
  NOT_ENOUGH_SERVER_MEMORY = 0x046A
  POSSIBLE_DEADLOCK = 0x046B
  MAPPED_ALIGNMENT = 0x046C
  SET_POWER_STATE_VETOED = 0x0474
  SET_POWER_STATE_FAILED = 0x0475
  TOO_MANY_LINKS = 0x0476
  OLD_WIN_VERSION = 0x047E
  APP_WRONG_OS = 0x047F
  SINGLE_INSTANCE_APP = 0x0480
  RMODE_APP = 0x0481
  INVALID_DLL = 0x0482
  NO_ASSOCIATION = 0x0483
  DDE_FAIL = 0x0484
  DLL_NOT_FOUND = 0x0485
  NO_MORE_USER_HANDLES = 0x0486
  MESSAGE_SYNC_ONLY = 0x0487
  SOURCE_ELEMENT_EMPTY = 0x0488
  DESTINATION_ELEMENT_FULL = 0x0489
  ILLEGAL_ELEMENT_ADDRESS = 0x048A
  MAGAZINE_NOT_PRESENT = 0x048B
  DEVICE_REINITIALIZATION_NEEDED = 0x048C
  DEVICE_REQUIRES_CLEANING = 0x048D
  DEVICE_DOOR_OPEN = 0x048E
  DEVICE_NOT_CONNECTED = 0x048F
  NOT_FOUND = 0x0490
  NO_MATCH = 0x0491
  SET_NOT_FOUND = 0x0492
  POINT_NOT_FOUND = 0x0493
  NO_TRACKING_SERVICE = 0x0494
  NO_VOLUME_ID = 0x0495
  UNABLE_TO_REMOVE_REPLACED = 0x0497
  UNABLE_TO_MOVE_REPLACEMENT = 0x0498
  UNABLE_TO_MOVE_REPLACEMENT_2 = 0x0499
  JOURNAL_DELETE_IN_PROGRESS = 0x049A
  JOURNAL_NOT_ACTIVE = 0x049B
  POTENTIAL_FILE_FOUND = 0x049C
  JOURNAL_ENTRY_DELETED = 0x049D
  SHUTDOWN_IS_SCHEDULED = 0x04A6
  SHUTDOWN_USERS_LOGGED_ON = 0x04A7
  BAD_DEVICE = 0x04B0
  CONNECTION_UNAVAIL = 0x04B1
  DEVICE_ALREADY_REMEMBERED = 0x04B2
  NO_NET_OR_BAD_PATH = 0x04B3
  BAD_PROVIDER = 0x04B4
  CANNOT_OPEN_PROFILE = 0x04B5
  BAD_PROFILE = 0x04B6
  NOT_CONTAINER = 0x04B7
  EXTENDED_ERROR = 0x04B8
  INVALID_GROUPNAME = 0x04B9
  INVALID_COMPUTERNAME = 0x04BA
  INVALID_EVENTNAME = 0x04BB
  INVALID_DOMAINNAME = 0x04BC
  INVALID_SERVICENAME = 0x04BD
  INVALID_NETNAME = 0x04BE
  INVALID_SHARENAME = 0x04BF
  INVALID_PASSWORDNAME = 0x04C0
  INVALID_MESSAGENAME = 0x04C1
  INVALID_MESSAGEDEST = 0x04C2
  SESSION_CREDENTIAL_CONFLICT = 0x04C3
  REMOTE_SESSION_LIMIT_EXCEEDED = 0x04C4
  DUP_DOMAINNAME = 0x04C5
  NO_NETWORK = 0x04C6
  CANCELLED = 0x04C7
  USER_MAPPED_FILE = 0x04C8
  CONNECTION_REFUSED = 0x04C9
  GRACEFUL_DISCONNECT = 0x04CA
  ADDRESS_ALREADY_ASSOCIATED = 0x04CB
  ADDRESS_NOT_ASSOCIATED = 0x04CC
  CONNECTION_INVALID = 0x04CD
  CONNECTION_ACTIVE = 0x04CE
  NETWORK_UNREACHABLE = 0x04CF
  HOST_UNREACHABLE = 0x04D0
  PROTOCOL_UNREACHABLE = 0x04D1
  PORT_UNREACHABLE = 0x04D2
  REQUEST_ABORTED = 0x04D3
  CONNECTION_ABORTED = 0x04D4
  RETRY = 0x04D5
  CONNECTION_COUNT_LIMIT = 0x04D6
  LOGIN_TIME_RESTRICTION = 0x04D7
  LOGIN_WKSTA_RESTRICTION = 0x04D8
  INCORRECT_ADDRESS = 0x04D9
  ALREADY_REGISTERED = 0x04DA
  SERVICE_NOT_FOUND = 0x04DB
  NOT_AUTHENTICATED = 0x04DC
  NOT_LOGGED_ON = 0x04DD
  CONTINUE = 0x04DE
  ALREADY_INITIALIZED = 0x04DF
  NO_MORE_DEVICES = 0x04E0
  NO_SUCH_SITE = 0x04E1
  DOMAIN_CONTROLLER_EXISTS = 0x04E2
  ONLY_IF_CONNECTED = 0x04E3
  OVERRIDE_NOCHANGES = 0x04E4
  BAD_USER_PROFILE = 0x04E5
  NOT_SUPPORTED_ON_SBS = 0x04E6
  SERVER_SHUTDOWN_IN_PROGRESS = 0x04E7
  HOST_DOWN = 0x04E8
  NON_ACCOUNT_SID = 0x04E9
  NON_DOMAIN_SID = 0x04EA
  APPHELP_BLOCK = 0x04EB
  ACCESS_DISABLED_BY_POLICY = 0x04EC
  REG_NAT_CONSUMPTION = 0x04ED
  CSCSHARE_OFFLINE = 0x04EE
  PKINIT_FAILURE = 0x04EF
  SMARTCARD_SUBSYSTEM_FAILURE = 0x04F0
  DOWNGRADE_DETECTED = 0x04F1
  MACHINE_LOCKED = 0x04F7
  CALLBACK_SUPPLIED_INVALID_DATA = 0x04F9
  SYNC_FOREGROUND_REFRESH_REQUIRED = 0x04FA
  DRIVER_BLOCKED = 0x04FB
  INVALID_IMPORT_OF_NON_DLL = 0x04FC
  ACCESS_DISABLED_WEBBLADE = 0x04FD
  ACCESS_DISABLED_WEBBLADE_TAMPER = 0x04FE
  RECOVERY_FAILURE = 0x04FF
  ALREADY_FIBER = 0x0500
  ALREADY_THREAD = 0x0501
  STACK_BUFFER_OVERRUN = 0x0502
  PARAMETER_QUOTA_EXCEEDED = 0x0503
  DEBUGGER_INACTIVE = 0x0504
  DELAY_LOAD_FAILED = 0x0505
  VDM_DISALLOWED = 0x0506
  UNIDENTIFIED_ERROR = 0x0507
  INVALID_CRUNTIME_PARAMETER = 0x0508
  BEYOND_VDL = 0x0509
  INCOMPATIBLE_SERVICE_SID_TYPE = 0x050A
  DRIVER_PROCESS_TERMINATED = 0x050B
  IMPLEMENTATION_LIMIT = 0x050C
  PROCESS_IS_PROTECTED = 0x050D
  SERVICE_NOTIFY_CLIENT_LAGGING = 0x050E
  DISK_QUOTA_EXCEEDED = 0x050F
  CONTENT_BLOCKED = 0x0510
  INCOMPATIBLE_SERVICE_PRIVILEGE = 0x0511
  INVALID_LABEL = 0x0513
  NOT_ALL_ASSIGNED = 0x0514
  SOME_NOT_MAPPED = 0x0515
  NO_QUOTAS_FOR_ACCOUNT = 0x0516
  LOCAL_USER_SESSION_KEY = 0x0517
  NULL_LM_PASSWORD = 0x0518
  UNKNOWN_REVISION = 0x0519
  REVISION_MISMATCH = 0x051A
  INVALID_OWNER = 0x051B
  INVALID_PRIMARY_GROUP = 0x051C
  NO_IMPERSONATION_TOKEN = 0x051D
  CANT_DISABLE_MANDATORY = 0x051E
  NO_LOGON_SERVERS = 0x051F
  NO_SUCH_LOGON_SESSION = 0x0520
  NO_SUCH_PRIVILEGE = 0x0521
  PRIVILEGE_NOT_HELD = 0x0522
  INVALID_ACCOUNT_NAME = 0x0523
  USER_EXISTS = 0x0524
  NO_SUCH_USER = 0x0525
  GROUP_EXISTS = 0x0526
  NO_SUCH_GROUP = 0x0527
  MEMBER_IN_GROUP = 0x0528
  MEMBER_NOT_IN_GROUP = 0x0529
  LAST_ADMIN = 0x052A
  WRONG_PASSWORD = 0x052B
  ILL_FORMED_PASSWORD = 0x052C
  PASSWORD_RESTRICTION = 0x052D
  LOGON_FAILURE = 0x052E
  ACCOUNT_RESTRICTION = 0x052F
  INVALID_LOGON_HOURS = 0x0530
  INVALID_WORKSTATION = 0x0531
  PASSWORD_EXPIRED = 0x0532
  ACCOUNT_DISABLED = 0x0533
  NONE_MAPPED = 0x0534
  TOO_MANY_LUIDS_REQUESTED = 0x0535
  LUIDS_EXHAUSTED = 0x0536
  INVALID_SUB_AUTHORITY = 0x0537
  INVALID_ACL = 0x0538
  INVALID_SID = 0x0539
  INVALID_SECURITY_DESCR = 0x053A
  BAD_INHERITANCE_ACL = 0x053C
  SERVER_DISABLED = 0x053D
  SERVER_NOT_DISABLED = 0x053E
  INVALID_ID_AUTHORITY = 0x053F
  ALLOTTED_SPACE_EXCEEDED = 0x0540
  INVALID_GROUP_ATTRIBUTES = 0x0541
  BAD_IMPERSONATION_LEVEL = 0x0542
  CANT_OPEN_ANONYMOUS = 0x0543
  BAD_VALIDATION_CLASS = 0x0544
  BAD_TOKEN_TYPE = 0x0545
  NO_SECURITY_ON_OBJECT = 0x0546
  CANT_ACCESS_DOMAIN_INFO = 0x0547
  INVALID_SERVER_STATE = 0x0548
  INVALID_DOMAIN_STATE = 0x0549
  INVALID_DOMAIN_ROLE = 0x054A
  NO_SUCH_DOMAIN = 0x054B
  DOMAIN_EXISTS = 0x054C
  DOMAIN_LIMIT_EXCEEDED = 0x054D
  INTERNAL_DB_CORRUPTION = 0x054E
  INTERNAL_ERROR = 0x054F
  GENERIC_NOT_MAPPED = 0x0550
  BAD_DESCRIPTOR_FORMAT = 0x0551
  NOT_LOGON_PROCESS = 0x0552
  LOGON_SESSION_EXISTS = 0x0553
  NO_SUCH_PACKAGE = 0x0554
  BAD_LOGON_SESSION_STATE = 0x0555
  LOGON_SESSION_COLLISION = 0x0556
  INVALID_LOGON_TYPE = 0x0557
  CANNOT_IMPERSONATE = 0x0558
  RXACT_INVALID_STATE = 0x0559
  RXACT_COMMIT_FAILURE = 0x055A
  SPECIAL_ACCOUNT = 0x055B
  SPECIAL_GROUP = 0x055C
  SPECIAL_USER = 0x055D
  MEMBERS_PRIMARY_GROUP = 0x055E
  TOKEN_ALREADY_IN_USE = 0x055F
  NO_SUCH_ALIAS = 0x0560
  MEMBER_NOT_IN_ALIAS = 0x0561
  MEMBER_IN_ALIAS = 0x0562
  ALIAS_EXISTS = 0x0563
  LOGON_NOT_GRANTED = 0x0564
  TOO_MANY_SECRETS = 0x0565
  SECRET_TOO_LONG = 0x0566
  INTERNAL_DB_ERROR = 0x0567
  TOO_MANY_CONTEXT_IDS = 0x0568
  LOGON_TYPE_NOT_GRANTED = 0x0569
  NT_CROSS_ENCRYPTION_REQUIRED = 0x056A
  NO_SUCH_MEMBER = 0x056B
  INVALID_MEMBER = 0x056C
  TOO_MANY_SIDS = 0x056D
  LM_CROSS_ENCRYPTION_REQUIRED = 0x056E
  NO_INHERITANCE = 0x056F
  FILE_CORRUPT = 0x0570
  DISK_CORRUPT = 0x0571
  NO_USER_SESSION_KEY = 0x0572
  LICENSE_QUOTA_EXCEEDED = 0x0573
  WRONG_TARGET_NAME = 0x0574
  MUTUAL_AUTH_FAILED = 0x0575
  TIME_SKEW = 0x0576
  CURRENT_DOMAIN_NOT_ALLOWED = 0x0577
  INVALID_WINDOW_HANDLE = 0x0578
  INVALID_MENU_HANDLE = 0x0579
  INVALID_CURSOR_HANDLE = 0x057A
  INVALID_ACCEL_HANDLE = 0x057B
  INVALID_HOOK_HANDLE = 0x057C
  INVALID_DWP_HANDLE = 0x057D
  TLW_WITH_WSCHILD = 0x057E
  CANNOT_FIND_WND_CLASS = 0x057F
  WINDOW_OF_OTHER_THREAD = 0x0580
  HOTKEY_ALREADY_REGISTERED = 0x0581
  CLASS_ALREADY_EXISTS = 0x0582
  CLASS_DOES_NOT_EXIST = 0x0583
  CLASS_HAS_WINDOWS = 0x0584
  INVALID_INDEX = 0x0585
  INVALID_ICON_HANDLE = 0x0586
  PRIVATE_DIALOG_INDEX = 0x0587
  LISTBOX_ID_NOT_FOUND = 0x0588
  NO_WILDCARD_CHARACTERS = 0x0589
  CLIPBOARD_NOT_OPEN = 0x058A
  HOTKEY_NOT_REGISTERED = 0x058B
  WINDOW_NOT_DIALOG = 0x058C
  CONTROL_ID_NOT_FOUND = 0x058D
  INVALID_COMBOBOX_MESSAGE = 0x058E
  WINDOW_NOT_COMBOBOX = 0x058F
  INVALID_EDIT_HEIGHT = 0x0590
  DC_NOT_FOUND = 0x0591
  INVALID_HOOK_FILTER = 0x0592
  INVALID_FILTER_PROC = 0x0593
  HOOK_NEEDS_HMOD = 0x0594
  GLOBAL_ONLY_HOOK = 0x0595
  JOURNAL_HOOK_SET = 0x0596
  HOOK_NOT_INSTALLED = 0x0597
  INVALID_LB_MESSAGE = 0x0598
  SETCOUNT_ON_BAD_LB = 0x0599
  LB_WITHOUT_TABSTOPS = 0x059A
  DESTROY_OBJECT_OF_OTHER_THREAD = 0x059B
  CHILD_WINDOW_MENU = 0x059C
  NO_SYSTEM_MENU = 0x059D
  INVALID_MSGBOX_STYLE = 0x059E
  INVALID_SPI_VALUE = 0x059F
  SCREEN_ALREADY_LOCKED = 0x05A0
  HWNDS_HAVE_DIFF_PARENT = 0x05A1
  NOT_CHILD_WINDOW = 0x05A2
  INVALID_GW_COMMAND = 0x05A3
  INVALID_THREAD_ID = 0x05A4
  NON_MDICHILD_WINDOW = 0x05A5
  POPUP_ALREADY_ACTIVE = 0x05A6
  NO_SCROLLBARS = 0x05A7
  INVALID_SCROLLBAR_RANGE = 0x05A8
  INVALID_SHOWWIN_COMMAND = 0x05A9
  NO_SYSTEM_RESOURCES = 0x05AA
  NONPAGED_SYSTEM_RESOURCES = 0x05AB
  PAGED_SYSTEM_RESOURCES = 0x05AC
  WORKING_SET_QUOTA = 0x05AD
  PAGEFILE_QUOTA = 0x05AE
  COMMITMENT_LIMIT = 0x05AF
  MENU_ITEM_NOT_FOUND = 0x05B0
  INVALID_KEYBOARD_HANDLE = 0x05B1
  HOOK_TYPE_NOT_ALLOWED = 0x05B2
  REQUIRES_INTERACTIVE_WINDOWSTATION = 0x05B3
  TIMEOUT = 0x05B4
  INVALID_MONITOR_HANDLE = 0x05B5
  INCORRECT_SIZE = 0x05B6
  SYMLINK_CLASS_DISABLED = 0x05B7
  SYMLINK_NOT_SUPPORTED = 0x05B8
  XML_PARSE_ERROR = 0x05B9
  XMLDSIG_ERROR = 0x05BA
  RESTART_APPLICATION = 0x05BB
  WRONG_COMPARTMENT = 0x05BC
  AUTHIP_FAILURE = 0x05BD
  NO_NVRAM_RESOURCES = 0x05BE
  EVENTLOG_FILE_CORRUPT = 0x05DC
  EVENTLOG_CANT_START = 0x05DD
  LOG_FILE_FULL = 0x05DE
  EVENTLOG_FILE_CHANGED = 0x05DF
  INVALID_TASK_NAME = 0x060E
  INVALID_TASK_INDEX = 0x060F
  THREAD_ALREADY_IN_TASK = 0x0610
  INSTALL_SERVICE_FAILURE = 0x0641
  INSTALL_USEREXIT = 0x0642
  INSTALL_FAILURE = 0x0643
  INSTALL_SUSPEND = 0x0644
  UNKNOWN_PRODUCT = 0x0645
  UNKNOWN_FEATURE = 0x0646
  UNKNOWN_COMPONENT = 0x0647
  UNKNOWN_PROPERTY = 0x0648
  INVALID_HANDLE_STATE = 0x0649
  BAD_CONFIGURATION = 0x064A
  INDEX_ABSENT = 0x064B
  INSTALL_SOURCE_ABSENT = 0x064C
  INSTALL_PACKAGE_VERSION = 0x064D
  PRODUCT_UNINSTALLED = 0x064E
  BAD_QUERY_SYNTAX = 0x064F
  INVALID_FIELD = 0x0650
  DEVICE_REMOVED = 0x0651
  INSTALL_ALREADY_RUNNING = 0x0652
  INSTALL_PACKAGE_OPEN_FAILED = 0x0653
  INSTALL_PACKAGE_INVALID = 0x0654
  INSTALL_UI_FAILURE = 0x0655
  INSTALL_LOG_FAILURE = 0x0656
  INSTALL_LANGUAGE_UNSUPPORTED = 0x0657
  INSTALL_TRANSFORM_FAILURE = 0x0658
  INSTALL_PACKAGE_REJECTED = 0x0659
  FUNCTION_NOT_CALLED = 0x065A
  FUNCTION_FAILED = 0x065B
  INVALID_TABLE = 0x065C
  DATATYPE_MISMATCH = 0x065D
  UNSUPPORTED_TYPE = 0x065E
  CREATE_FAILED = 0x065F
  INSTALL_TEMP_UNWRITABLE = 0x0660
  INSTALL_PLATFORM_UNSUPPORTED = 0x0661
  INSTALL_NOTUSED = 0x0662
  PATCH_PACKAGE_OPEN_FAILED = 0x0663
  PATCH_PACKAGE_INVALID = 0x0664
  PATCH_PACKAGE_UNSUPPORTED = 0x0665
  PRODUCT_VERSION = 0x0666
  INVALID_COMMAND_LINE = 0x0667
  INSTALL_REMOTE_DISALLOWED = 0x0668
  SUCCESS_REBOOT_INITIATED = 0x0669
  PATCH_TARGET_NOT_FOUND = 0x066A
  PATCH_PACKAGE_REJECTED = 0x066B
  INSTALL_TRANSFORM_REJECTED = 0x066C
  INSTALL_REMOTE_PROHIBITED = 0x066D
  PATCH_REMOVAL_UNSUPPORTED = 0x066E
  UNKNOWN_PATCH = 0x066F
  PATCH_NO_SEQUENCE = 0x0670
  PATCH_REMOVAL_DISALLOWED = 0x0671
  INVALID_PATCH_XML = 0x0672
  PATCH_MANAGED_ADVERTISED_PRODUCT = 0x0673
  INSTALL_SERVICE_SAFEBOOT = 0x0674
  FAIL_FAST_EXCEPTION = 0x0675
  RPC_S_INVALID_STRING_BINDING = 0x06A4
  RPC_S_WRONG_KIND_OF_BINDING = 0x06A5
  RPC_S_INVALID_BINDING = 0x06A6
  RPC_S_PROTSEQ_NOT_SUPPORTED = 0x06A7
  RPC_S_INVALID_RPC_PROTSEQ = 0x06A8
  RPC_S_INVALID_STRING_UUID = 0x06A9
  RPC_S_INVALID_ENDPOINT_FORMAT = 0x06AA
  RPC_S_INVALID_NET_ADDR = 0x06AB
  RPC_S_NO_ENDPOINT_FOUND = 0x06AC
  RPC_S_INVALID_TIMEOUT = 0x06AD
  RPC_S_OBJECT_NOT_FOUND = 0x06AE
  RPC_S_ALREADY_REGISTERED = 0x06AF
  RPC_S_TYPE_ALREADY_REGISTERED = 0x06B0
  RPC_S_ALREADY_LISTENING = 0x06B1
  RPC_S_NO_PROTSEQS_REGISTERED = 0x06B2
  RPC_S_NOT_LISTENING = 0x06B3
  RPC_S_UNKNOWN_MGR_TYPE = 0x06B4
  RPC_S_UNKNOWN_IF = 0x06B5
  RPC_S_NO_BINDINGS = 0x06B6
  RPC_S_NO_PROTSEQS = 0x06B7
  RPC_S_CANT_CREATE_ENDPOINT = 0x06B8
  RPC_S_OUT_OF_RESOURCES = 0x06B9
  RPC_S_SERVER_UNAVAILABLE = 0x06BA
  RPC_S_SERVER_TOO_BUSY = 0x06BB
  RPC_S_INVALID_NETWORK_OPTIONS = 0x06BC
  RPC_S_NO_CALL_ACTIVE = 0x06BD
  RPC_S_CALL_FAILED = 0x06BE
  RPC_S_CALL_FAILED_DNE = 0x06BF
  RPC_S_PROTOCOL_ERROR = 0x06C0
  RPC_S_PROXY_ACCESS_DENIED = 0x06C1
  RPC_S_UNSUPPORTED_TRANS_SYN = 0x06C2
  RPC_S_UNSUPPORTED_TYPE = 0x06C4
  RPC_S_INVALID_TAG = 0x06C5
  RPC_S_INVALID_BOUND = 0x06C6
  RPC_S_NO_ENTRY_NAME = 0x06C7
  RPC_S_INVALID_NAME_SYNTAX = 0x06C8
  RPC_S_UNSUPPORTED_NAME_SYNTAX = 0x06C9
  RPC_S_UUID_NO_ADDRESS = 0x06CB
  RPC_S_DUPLICATE_ENDPOINT = 0x06CC
  RPC_S_UNKNOWN_AUTHN_TYPE = 0x06CD
  RPC_S_MAX_CALLS_TOO_SMALL = 0x06CE
  RPC_S_STRING_TOO_LONG = 0x06CF
  RPC_S_PROTSEQ_NOT_FOUND = 0x06D0
  RPC_S_PROCNUM_OUT_OF_RANGE = 0x06D1
  RPC_S_BINDING_HAS_NO_AUTH = 0x06D2
  RPC_S_UNKNOWN_AUTHN_SERVICE = 0x06D3
  RPC_S_UNKNOWN_AUTHN_LEVEL = 0x06D4
  RPC_S_INVALID_AUTH_IDENTITY = 0x06D5
  RPC_S_UNKNOWN_AUTHZ_SERVICE = 0x06D6
  EPT_S_INVALID_ENTRY = 0x06D7
  EPT_S_CANT_PERFORM_OP = 0x06D8
  EPT_S_NOT_REGISTERED = 0x06D9
  RPC_S_NOTHING_TO_EXPORT = 0x06DA
  RPC_S_INCOMPLETE_NAME = 0x06DB
  RPC_S_INVALID_VERS_OPTION = 0x06DC
  RPC_S_NO_MORE_MEMBERS = 0x06DD
  RPC_S_NOT_ALL_OBJS_UNEXPORTED = 0x06DE
  RPC_S_INTERFACE_NOT_FOUND = 0x06DF
  RPC_S_ENTRY_ALREADY_EXISTS = 0x06E0
  RPC_S_ENTRY_NOT_FOUND = 0x06E1
  RPC_S_NAME_SERVICE_UNAVAILABLE = 0x06E2
  RPC_S_INVALID_NAF_ID = 0x06E3
  RPC_S_CANNOT_SUPPORT = 0x06E4
  RPC_S_NO_CONTEXT_AVAILABLE = 0x06E5
  RPC_S_INTERNAL_ERROR = 0x06E6
  RPC_S_ZERO_DIVIDE = 0x06E7
  RPC_S_ADDRESS_ERROR = 0x06E8
  RPC_S_FP_DIV_ZERO = 0x06E9
  RPC_S_FP_UNDERFLOW = 0x06EA
  RPC_S_FP_OVERFLOW = 0x06EB
  RPC_X_NO_MORE_ENTRIES = 0x06EC
  RPC_X_SS_CHAR_TRANS_OPEN_FAIL = 0x06ED
  RPC_X_SS_CHAR_TRANS_SHORT_FILE = 0x06EE
  RPC_X_SS_IN_NULL_CONTEXT = 0x06EF
  RPC_X_SS_CONTEXT_DAMAGED = 0x06F1
  RPC_X_SS_HANDLES_MISMATCH = 0x06F2
  RPC_X_SS_CANNOT_GET_CALL_HANDLE = 0x06F3
  RPC_X_NULL_REF_POINTER = 0x06F4
  RPC_X_ENUM_VALUE_OUT_OF_RANGE = 0x06F5
  RPC_X_BYTE_COUNT_TOO_SMALL = 0x06F6
  RPC_X_BAD_STUB_DATA = 0x06F7
  INVALID_USER_BUFFER = 0x06F8
  UNRECOGNIZED_MEDIA = 0x06F9
  NO_TRUST_LSA_SECRET = 0x06FA
  NO_TRUST_SAM_ACCOUNT = 0x06FB
  TRUSTED_DOMAIN_FAILURE = 0x06FC
  TRUSTED_RELATIONSHIP_FAILURE = 0x06FD
  TRUST_FAILURE = 0x06FE
  RPC_S_CALL_IN_PROGRESS = 0x06FF
  NETLOGON_NOT_STARTED = 0x0700
  ACCOUNT_EXPIRED = 0x0701
  REDIRECTOR_HAS_OPEN_HANDLES = 0x0702
  PRINTER_DRIVER_ALREADY_INSTALLED = 0x0703
  UNKNOWN_PORT = 0x0704
  UNKNOWN_PRINTER_DRIVER = 0x0705
  UNKNOWN_PRINTPROCESSOR = 0x0706
  INVALID_SEPARATOR_FILE = 0x0707
  INVALID_PRIORITY = 0x0708
  INVALID_PRINTER_NAME = 0x0709
  PRINTER_ALREADY_EXISTS = 0x070A
  INVALID_PRINTER_COMMAND = 0x070B
  INVALID_DATATYPE = 0x070C
  INVALID_ENVIRONMENT = 0x070D
  RPC_S_NO_MORE_BINDINGS = 0x070E
  NOLOGON_INTERDOMAIN_TRUST_ACCOUNT = 0x070F
  NOLOGON_WORKSTATION_TRUST_ACCOUNT = 0x0710
  NOLOGON_SERVER_TRUST_ACCOUNT = 0x0711
  DOMAIN_TRUST_INCONSISTENT = 0x0712
  SERVER_HAS_OPEN_HANDLES = 0x0713
  RESOURCE_DATA_NOT_FOUND = 0x0714
  RESOURCE_TYPE_NOT_FOUND = 0x0715
  RESOURCE_NAME_NOT_FOUND = 0x0716
  RESOURCE_LANG_NOT_FOUND = 0x0717
  NOT_ENOUGH_QUOTA = 0x0718
  RPC_S_NO_INTERFACES = 0x0719
  RPC_S_CALL_CANCELLED = 0x071A
  RPC_S_BINDING_INCOMPLETE = 0x071B
  RPC_S_COMM_FAILURE = 0x071C
  RPC_S_UNSUPPORTED_AUTHN_LEVEL = 0x071D
  RPC_S_NO_PRINC_NAME = 0x071E
  RPC_S_NOT_RPC_ERROR = 0x071F
  RPC_S_UUID_LOCAL_ONLY = 0x0720
  RPC_S_SEC_PKG_ERROR = 0x0721
  RPC_S_NOT_CANCELLED = 0x0722
  RPC_X_INVALID_ES_ACTION = 0x0723
  RPC_X_WRONG_ES_VERSION = 0x0724
  RPC_X_WRONG_STUB_VERSION = 0x0725
  RPC_X_INVALID_PIPE_OBJECT = 0x0726
  RPC_X_WRONG_PIPE_ORDER = 0x0727
  RPC_X_WRONG_PIPE_VERSION = 0x0728
  RPC_S_COOKIE_AUTH_FAILED = 0x0729
  RPC_S_GROUP_MEMBER_NOT_FOUND = 0x076A
  EPT_S_CANT_CREATE = 0x076B
  RPC_S_INVALID_OBJECT = 0x076C
  INVALID_TIME = 0x076D
  INVALID_FORM_NAME = 0x076E
  INVALID_FORM_SIZE = 0x076F
  ALREADY_WAITING = 0x0770
  PRINTER_DELETED = 0x0771
  INVALID_PRINTER_STATE = 0x0772
  PASSWORD_MUST_CHANGE = 0x0773
  DOMAIN_CONTROLLER_NOT_FOUND = 0x0774
  ACCOUNT_LOCKED_OUT = 0x0775
  OR_INVALID_OXID = 0x0776
  OR_INVALID_OID = 0x0777
  OR_INVALID_SET = 0x0778
  RPC_S_SEND_INCOMPLETE = 0x0779
  RPC_S_INVALID_ASYNC_HANDLE = 0x077A
  RPC_S_INVALID_ASYNC_CALL = 0x077B
  RPC_X_PIPE_CLOSED = 0x077C
  RPC_X_PIPE_DISCIPLINE_ERROR = 0x077D
  RPC_X_PIPE_EMPTY = 0x077E
  NO_SITENAME = 0x077F
  CANT_ACCESS_FILE = 0x0780
  CANT_RESOLVE_FILENAME = 0x0781
  RPC_S_ENTRY_TYPE_MISMATCH = 0x0782
  RPC_S_NOT_ALL_OBJS_EXPORTED = 0x0783
  RPC_S_INTERFACE_NOT_EXPORTED = 0x0784
  RPC_S_PROFILE_NOT_ADDED = 0x0785
  RPC_S_PRF_ELT_NOT_ADDED = 0x0786
  RPC_S_PRF_ELT_NOT_REMOVED = 0x0787
  RPC_S_GRP_ELT_NOT_ADDED = 0x0788
  RPC_S_GRP_ELT_NOT_REMOVED = 0x0789
  KM_DRIVER_BLOCKED = 0x078A
  CONTEXT_EXPIRED = 0x078B
  PER_USER_TRUST_QUOTA_EXCEEDED = 0x078C
  ALL_USER_TRUST_QUOTA_EXCEEDED = 0x078D
  USER_DELETE_TRUST_QUOTA_EXCEEDED = 0x078E
  AUTHENTICATION_FIREWALL_FAILED = 0x078F
  REMOTE_PRINT_CONNECTIONS_BLOCKED = 0x0790
  NTLM_BLOCKED = 0x0791
  INVALID_PIXEL_FORMAT = 0x07D0
  BAD_DRIVER = 0x07D1
  INVALID_WINDOW_STYLE = 0x07D2
  METAFILE_NOT_SUPPORTED = 0x07D3
  TRANSFORM_NOT_SUPPORTED = 0x07D4
  CLIPPING_NOT_SUPPORTED = 0x07D5
  INVALID_CMM = 0x07DA
  INVALID_PROFILE = 0x07DB
  TAG_NOT_FOUND = 0x07DC
  TAG_NOT_PRESENT = 0x07DD
  DUPLICATE_TAG = 0x07DE
  PROFILE_NOT_ASSOCIATED_WITH_DEVICE = 0x07DF
  PROFILE_NOT_FOUND = 0x07E0
  INVALID_COLORSPACE = 0x07E1
  ICM_NOT_ENABLED = 0x07E2
  DELETING_ICM_XFORM = 0x07E3
  INVALID_TRANSFORM = 0x07E4
  COLORSPACE_MISMATCH = 0x07E5
  INVALID_COLORINDEX = 0x07E6
  PROFILE_DOES_NOT_MATCH_DEVICE = 0x07E7
  CONNECTED_OTHER_PASSWORD = 0x083C
  CONNECTED_OTHER_PASSWORD_DEFAULT = 0x083D
  BAD_USERNAME = 0x089A
  NOT_CONNECTED = 0x08CA
  OPEN_FILES = 0x0961
  ACTIVE_CONNECTIONS = 0x0962
  DEVICE_IN_USE = 0x0964
  UNKNOWN_PRINT_MONITOR = 0x0BB8
  PRINTER_DRIVER_IN_USE = 0x0BB9
  SPOOL_FILE_NOT_FOUND = 0x0BBA
  SPL_NO_STARTDOC = 0x0BBB
  SPL_NO_ADDJOB = 0x0BBC
  PRINT_PROCESSOR_ALREADY_INSTALLED = 0x0BBD
  PRINT_MONITOR_ALREADY_INSTALLED = 0x0BBE
  INVALID_PRINT_MONITOR = 0x0BBF
  PRINT_MONITOR_IN_USE = 0x0BC0
  PRINTER_HAS_JOBS_QUEUED = 0x0BC1
  SUCCESS_REBOOT_REQUIRED = 0x0BC2
  SUCCESS_RESTART_REQUIRED = 0x0BC3
  PRINTER_NOT_FOUND = 0x0BC4
  PRINTER_DRIVER_WARNED = 0x0BC5
  PRINTER_DRIVER_BLOCKED = 0x0BC6
  PRINTER_DRIVER_PACKAGE_IN_USE = 0x0BC7
  CORE_DRIVER_PACKAGE_NOT_FOUND = 0x0BC8
  FAIL_REBOOT_REQUIRED = 0x0BC9
  FAIL_REBOOT_INITIATED = 0x0BCA
  PRINTER_DRIVER_DOWNLOAD_NEEDED = 0x0BCB
  PRINT_JOB_RESTART_REQUIRED = 0x0BCC
  IO_REISSUE_AS_CACHED = 0x0F6E
  WINS_INTERNAL = 0x0FA0
  CAN_NOT_DEL_LOCAL_WINS = 0x0FA1
  STATIC_INIT = 0x0FA2
  INC_BACKUP = 0x0FA3
  FULL_BACKUP = 0x0FA4
  REC_NON_EXISTENT = 0x0FA5
  RPL_NOT_ALLOWED = 0x0FA6
  PEERDIST_CONTENTINFO_VERSION_UNSUPPORTED = 0x0FD2
  PEERDIST_CANNOT_PARSE_CONTENTINFO = 0x0FD3
  PEERDIST_MISSING_DATA = 0x0FD4
  PEERDIST_NO_MORE = 0x0FD5
  PEERDIST_NOT_INITIALIZED = 0x0FD6
  PEERDIST_ALREADY_INITIALIZED = 0x0FD7
  PEERDIST_SHUTDOWN_IN_PROGRESS = 0x0FD8
  PEERDIST_INVALIDATED = 0x0FD9
  PEERDIST_ALREADY_EXISTS = 0x0FDA
  PEERDIST_OPERATION_NOTFOUND = 0x0FDB
  PEERDIST_ALREADY_COMPLETED = 0x0FDC
  PEERDIST_OUT_OF_BOUNDS = 0x0FDD
  PEERDIST_VERSION_UNSUPPORTED = 0x0FDE
  PEERDIST_INVALID_CONFIGURATION = 0x0FDF
  PEERDIST_NOT_LICENSED = 0x0FE0
  PEERDIST_SERVICE_UNAVAILABLE = 0x0FE1
  DHCP_ADDRESS_CONFLICT = 0x1004
  WMI_GUID_NOT_FOUND = 0x1068
  WMI_INSTANCE_NOT_FOUND = 0x1069
  WMI_ITEMID_NOT_FOUND = 0x106A
  WMI_TRY_AGAIN = 0x106B
  WMI_DP_NOT_FOUND = 0x106C
  WMI_UNRESOLVED_INSTANCE_REF = 0x106D
  WMI_ALREADY_ENABLED = 0x106E
  WMI_GUID_DISCONNECTED = 0x106F
  WMI_SERVER_UNAVAILABLE = 0x1070
  WMI_DP_FAILED = 0x1071
  WMI_INVALID_MOF = 0x1072
  WMI_INVALID_REGINFO = 0x1073
  WMI_ALREADY_DISABLED = 0x1074
  WMI_READ_ONLY = 0x1075
  WMI_SET_FAILURE = 0x1076
  INVALID_MEDIA = 0x10CC
  INVALID_LIBRARY = 0x10CD
  INVALID_MEDIA_POOL = 0x10CE
  DRIVE_MEDIA_MISMATCH = 0x10CF
  MEDIA_OFFLINE = 0x10D0
  LIBRARY_OFFLINE = 0x10D1
  EMPTY = 0x10D2
  NOT_EMPTY = 0x10D3
  MEDIA_UNAVAILABLE = 0x10D4
  RESOURCE_DISABLED = 0x10D5
  INVALID_CLEANER = 0x10D6
  UNABLE_TO_CLEAN = 0x10D7
  OBJECT_NOT_FOUND = 0x10D8
  DATABASE_FAILURE = 0x10D9
  DATABASE_FULL = 0x10DA
  MEDIA_INCOMPATIBLE = 0x10DB
  RESOURCE_NOT_PRESENT = 0x10DC
  INVALID_OPERATION = 0x10DD
  MEDIA_NOT_AVAILABLE = 0x10DE
  DEVICE_NOT_AVAILABLE = 0x10DF
  REQUEST_REFUSED = 0x10E0
  INVALID_DRIVE_OBJECT = 0x10E1
  LIBRARY_FULL = 0x10E2
  MEDIUM_NOT_ACCESSIBLE = 0x10E3
  UNABLE_TO_LOAD_MEDIUM = 0x10E4
  UNABLE_TO_INVENTORY_DRIVE = 0x10E5
  UNABLE_TO_INVENTORY_SLOT = 0x10E6
  UNABLE_TO_INVENTORY_TRANSPORT = 0x10E7
  TRANSPORT_FULL = 0x10E8
  CONTROLLING_IEPORT = 0x10E9
  UNABLE_TO_EJECT_MOUNTED_MEDIA = 0x10EA
  CLEANER_SLOT_SET = 0x10EB
  CLEANER_SLOT_NOT_SET = 0x10EC
  CLEANER_CARTRIDGE_SPENT = 0x10ED
  UNEXPECTED_OMID = 0x10EE
  CANT_DELETE_LAST_ITEM = 0x10EF
  MESSAGE_EXCEEDS_MAX_SIZE = 0x10F0
  VOLUME_CONTAINS_SYS_FILES = 0x10F1
  INDIGENOUS_TYPE = 0x10F2
  NO_SUPPORTING_DRIVES = 0x10F3
  CLEANER_CARTRIDGE_INSTALLED = 0x10F4
  IEPORT_FULL = 0x10F5
  FILE_OFFLINE = 0x10FE
  REMOTE_STORAGE_NOT_ACTIVE = 0x10FF
  REMOTE_STORAGE_MEDIA_ERROR = 0x1100
  NOT_A_REPARSE_POINT = 0x1126
  REPARSE_ATTRIBUTE_CONFLICT = 0x1127
  INVALID_REPARSE_DATA = 0x1128
  REPARSE_TAG_INVALID = 0x1129
  REPARSE_TAG_MISMATCH = 0x112A
  VOLUME_NOT_SIS_ENABLED = 0x1194
  DEPENDENT_RESOURCE_EXISTS = 0x1389
  DEPENDENCY_NOT_FOUND = 0x138A
  DEPENDENCY_ALREADY_EXISTS = 0x138B
  RESOURCE_NOT_ONLINE = 0x138C
  HOST_NODE_NOT_AVAILABLE = 0x138D
  RESOURCE_NOT_AVAILABLE = 0x138E
  RESOURCE_NOT_FOUND = 0x138F
  SHUTDOWN_CLUSTER = 0x1390
  CANT_EVICT_ACTIVE_NODE = 0x1391
  OBJECT_ALREADY_EXISTS = 0x1392
  OBJECT_IN_LIST = 0x1393
  GROUP_NOT_AVAILABLE = 0x1394
  GROUP_NOT_FOUND = 0x1395
  GROUP_NOT_ONLINE = 0x1396
  HOST_NODE_NOT_RESOURCE_OWNER = 0x1397
  HOST_NODE_NOT_GROUP_OWNER = 0x1398
  RESMON_CREATE_FAILED = 0x1399
  RESMON_ONLINE_FAILED = 0x139A
  RESOURCE_ONLINE = 0x139B
  QUORUM_RESOURCE = 0x139C
  NOT_QUORUM_CAPABLE = 0x139D
  CLUSTER_SHUTTING_DOWN = 0x139E
  INVALID_STATE = 0x139F
  RESOURCE_PROPERTIES_STORED = 0x13A0
  NOT_QUORUM_CLASS = 0x13A1
  CORE_RESOURCE = 0x13A2
  QUORUM_RESOURCE_ONLINE_FAILED = 0x13A3
  QUORUMLOG_OPEN_FAILED = 0x13A4
  CLUSTERLOG_CORRUPT = 0x13A5
  CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE = 0x13A6
  CLUSTERLOG_EXCEEDS_MAXSIZE = 0x13A7
  CLUSTERLOG_CHKPOINT_NOT_FOUND = 0x13A8
  CLUSTERLOG_NOT_ENOUGH_SPACE = 0x13A9
  QUORUM_OWNER_ALIVE = 0x13AA
  NETWORK_NOT_AVAILABLE = 0x13AB
  NODE_NOT_AVAILABLE = 0x13AC
  ALL_NODES_NOT_AVAILABLE = 0x13AD
  RESOURCE_FAILED = 0x13AE
  CLUSTER_INVALID_NODE = 0x13AF
  CLUSTER_NODE_EXISTS = 0x13B0
  CLUSTER_JOIN_IN_PROGRESS = 0x13B1
  CLUSTER_NODE_NOT_FOUND = 0x13B2
  CLUSTER_LOCAL_NODE_NOT_FOUND = 0x13B3
  CLUSTER_NETWORK_EXISTS = 0x13B4
  CLUSTER_NETWORK_NOT_FOUND = 0x13B5
  CLUSTER_NETINTERFACE_EXISTS = 0x13B6
  CLUSTER_NETINTERFACE_NOT_FOUND = 0x13B7
  CLUSTER_INVALID_REQUEST = 0x13B8
  CLUSTER_INVALID_NETWORK_PROVIDER = 0x13B9
  CLUSTER_NODE_DOWN = 0x13BA
  CLUSTER_NODE_UNREACHABLE = 0x13BB
  CLUSTER_NODE_NOT_MEMBER = 0x13BC
  CLUSTER_JOIN_NOT_IN_PROGRESS = 0x13BD
  CLUSTER_INVALID_NETWORK = 0x13BE
  CLUSTER_NODE_UP = 0x13C0
  CLUSTER_IPADDR_IN_USE = 0x13C1
  CLUSTER_NODE_NOT_PAUSED = 0x13C2
  CLUSTER_NO_SECURITY_CONTEXT = 0x13C3
  CLUSTER_NETWORK_NOT_INTERNAL = 0x13C4
  CLUSTER_NODE_ALREADY_UP = 0x13C5
  CLUSTER_NODE_ALREADY_DOWN = 0x13C6
  CLUSTER_NETWORK_ALREADY_ONLINE = 0x13C7
  CLUSTER_NETWORK_ALREADY_OFFLINE = 0x13C8
  CLUSTER_NODE_ALREADY_MEMBER = 0x13C9
  CLUSTER_LAST_INTERNAL_NETWORK = 0x13CA
  CLUSTER_NETWORK_HAS_DEPENDENTS = 0x13CB
  INVALID_OPERATION_ON_QUORUM = 0x13CC
  DEPENDENCY_NOT_ALLOWED = 0x13CD
  CLUSTER_NODE_PAUSED = 0x13CE
  NODE_CANT_HOST_RESOURCE = 0x13CF
  CLUSTER_NODE_NOT_READY = 0x13D0
  CLUSTER_NODE_SHUTTING_DOWN = 0x13D1
  CLUSTER_JOIN_ABORTED = 0x13D2
  CLUSTER_INCOMPATIBLE_VERSIONS = 0x13D3
  CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED = 0x13D4
  CLUSTER_SYSTEM_CONFIG_CHANGED = 0x13D5
  CLUSTER_RESOURCE_TYPE_NOT_FOUND = 0x13D6
  CLUSTER_RESTYPE_NOT_SUPPORTED = 0x13D7
  CLUSTER_RESNAME_NOT_FOUND = 0x13D8
  CLUSTER_NO_RPC_PACKAGES_REGISTERED = 0x13D9
  CLUSTER_OWNER_NOT_IN_PREFLIST = 0x13DA
  CLUSTER_DATABASE_SEQMISMATCH = 0x13DB
  RESMON_INVALID_STATE = 0x13DC
  CLUSTER_GUM_NOT_LOCKER = 0x13DD
  QUORUM_DISK_NOT_FOUND = 0x13DE
  DATABASE_BACKUP_CORRUPT = 0x13DF
  CLUSTER_NODE_ALREADY_HAS_DFS_ROOT = 0x13E0
  RESOURCE_PROPERTY_UNCHANGEABLE = 0x13E1
  CLUSTER_MEMBERSHIP_INVALID_STATE = 0x1702
  CLUSTER_QUORUMLOG_NOT_FOUND = 0x1703
  CLUSTER_MEMBERSHIP_HALT = 0x1704
  CLUSTER_INSTANCE_ID_MISMATCH = 0x1705
  CLUSTER_NETWORK_NOT_FOUND_FOR_IP = 0x1706
  CLUSTER_PROPERTY_DATA_TYPE_MISMATCH = 0x1707
  CLUSTER_EVICT_WITHOUT_CLEANUP = 0x1708
  CLUSTER_PARAMETER_MISMATCH = 0x1709
  NODE_CANNOT_BE_CLUSTERED = 0x170A
  CLUSTER_WRONG_OS_VERSION = 0x170B
  CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME = 0x170C
  CLUSCFG_ALREADY_COMMITTED = 0x170D
  CLUSCFG_ROLLBACK_FAILED = 0x170E
  CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT = 0x170F
  CLUSTER_OLD_VERSION = 0x1710
  CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME = 0x1711
  CLUSTER_NO_NET_ADAPTERS = 0x1712
  CLUSTER_POISONED = 0x1713
  CLUSTER_GROUP_MOVING = 0x1714
  CLUSTER_RESOURCE_TYPE_BUSY = 0x1715
  RESOURCE_CALL_TIMED_OUT = 0x1716
  INVALID_CLUSTER_IPV6_ADDRESS = 0x1717
  CLUSTER_INTERNAL_INVALID_FUNCTION = 0x1718
  CLUSTER_PARAMETER_OUT_OF_BOUNDS = 0x1719
  CLUSTER_PARTIAL_SEND = 0x171A
  CLUSTER_REGISTRY_INVALID_FUNCTION = 0x171B
  CLUSTER_INVALID_STRING_TERMINATION = 0x171C
  CLUSTER_INVALID_STRING_FORMAT = 0x171D
  CLUSTER_DATABASE_TRANSACTION_IN_PROGRESS = 0x171E
  CLUSTER_DATABASE_TRANSACTION_NOT_IN_PROGRESS = 0x171F
  CLUSTER_NULL_DATA = 0x1720
  CLUSTER_PARTIAL_READ = 0x1721
  CLUSTER_PARTIAL_WRITE = 0x1722
  CLUSTER_CANT_DESERIALIZE_DATA = 0x1723
  DEPENDENT_RESOURCE_PROPERTY_CONFLICT = 0x1724
  CLUSTER_NO_QUORUM = 0x1725
  CLUSTER_INVALID_IPV6_NETWORK = 0x1726
  CLUSTER_INVALID_IPV6_TUNNEL_NETWORK = 0x1727
  QUORUM_NOT_ALLOWED_IN_THIS_GROUP = 0x1728
  DEPENDENCY_TREE_TOO_COMPLEX = 0x1729
  EXCEPTION_IN_RESOURCE_CALL = 0x172A
  CLUSTER_RHS_FAILED_INITIALIZATION = 0x172B
  CLUSTER_NOT_INSTALLED = 0x172C
  CLUSTER_RESOURCES_MUST_BE_ONLINE_ON_THE_SAME_NODE = 0x172D
  CLUSTER_MAX_NODES_IN_CLUSTER = 0x172E
  CLUSTER_TOO_MANY_NODES = 0x172F
  CLUSTER_OBJECT_ALREADY_USED = 0x1730
  NONCORE_GROUPS_FOUND = 0x1731
  FILE_SHARE_RESOURCE_CONFLICT = 0x1732
  CLUSTER_EVICT_INVALID_REQUEST = 0x1733
  CLUSTER_SINGLETON_RESOURCE = 0x1734
  CLUSTER_GROUP_SINGLETON_RESOURCE = 0x1735
  CLUSTER_RESOURCE_PROVIDER_FAILED = 0x1736
  CLUSTER_RESOURCE_CONFIGURATION_ERROR = 0x1737
  CLUSTER_GROUP_BUSY = 0x1738
  CLUSTER_NOT_SHARED_VOLUME = 0x1739
  CLUSTER_INVALID_SECURITY_DESCRIPTOR = 0x173A
  CLUSTER_SHARED_VOLUMES_IN_USE = 0x173B
  CLUSTER_USE_SHARED_VOLUMES_API = 0x173C
  CLUSTER_BACKUP_IN_PROGRESS = 0x173D
  NON_CSV_PATH = 0x173E
  CSV_VOLUME_NOT_LOCAL = 0x173F
  CLUSTER_WATCHDOG_TERMINATING = 0x1740
  ENCRYPTION_FAILED = 0x1770
  DECRYPTION_FAILED = 0x1771
  FILE_ENCRYPTED = 0x1772
  NO_RECOVERY_POLICY = 0x1773
  NO_EFS = 0x1774
  WRONG_EFS = 0x1775
  NO_USER_KEYS = 0x1776
  FILE_NOT_ENCRYPTED = 0x1777
  NOT_EXPORT_FORMAT = 0x1778
  FILE_READ_ONLY = 0x1779
  DIR_EFS_DISALLOWED = 0x177A
  EFS_SERVER_NOT_TRUSTED = 0x177B
  BAD_RECOVERY_POLICY = 0x177C
  EFS_ALG_BLOB_TOO_BIG = 0x177D
  VOLUME_NOT_SUPPORT_EFS = 0x177E
  EFS_DISABLED = 0x177F
  EFS_VERSION_NOT_SUPPORT = 0x1780
  CS_ENCRYPTION_INVALID_SERVER_RESPONSE = 0x1781
  CS_ENCRYPTION_UNSUPPORTED_SERVER = 0x1782
  CS_ENCRYPTION_EXISTING_ENCRYPTED_FILE = 0x1783
  CS_ENCRYPTION_NEW_ENCRYPTED_FILE = 0x1784
  CS_ENCRYPTION_FILE_NOT_CSE = 0x1785
  NO_BROWSER_SERVERS_FOUND = 0x17E6
  SCHED_E_SERVICE_NOT_LOCALSYSTEM = 0x1838
  LOG_SECTOR_INVALID = 0x19C8
  LOG_SECTOR_PARITY_INVALID = 0x19C9
  LOG_SECTOR_REMAPPED = 0x19CA
  LOG_BLOCK_INCOMPLETE = 0x19CB
  LOG_INVALID_RANGE = 0x19CC
  LOG_BLOCKS_EXHAUSTED = 0x19CD
  LOG_READ_CONTEXT_INVALID = 0x19CE
  LOG_RESTART_INVALID = 0x19CF
  LOG_BLOCK_VERSION = 0x19D0
  LOG_BLOCK_INVALID = 0x19D1
  LOG_READ_MODE_INVALID = 0x19D2
  LOG_NO_RESTART = 0x19D3
  LOG_METADATA_CORRUPT = 0x19D4
  LOG_METADATA_INVALID = 0x19D5
  LOG_METADATA_INCONSISTENT = 0x19D6
  LOG_RESERVATION_INVALID = 0x19D7
  LOG_CANT_DELETE = 0x19D8
  LOG_CONTAINER_LIMIT_EXCEEDED = 0x19D9
  LOG_START_OF_LOG = 0x19DA
  LOG_POLICY_ALREADY_INSTALLED = 0x19DB
  LOG_POLICY_NOT_INSTALLED = 0x19DC
  LOG_POLICY_INVALID = 0x19DD
  LOG_POLICY_CONFLICT = 0x19DE
  LOG_PINNED_ARCHIVE_TAIL = 0x19DF
  LOG_RECORD_NONEXISTENT = 0x19E0
  LOG_RECORDS_RESERVED_INVALID = 0x19E1
  LOG_SPACE_RESERVED_INVALID = 0x19E2
  LOG_TAIL_INVALID = 0x19E3
  LOG_FULL = 0x19E4
  COULD_NOT_RESIZE_LOG = 0x19E5
  LOG_MULTIPLEXED = 0x19E6
  LOG_DEDICATED = 0x19E7
  LOG_ARCHIVE_NOT_IN_PROGRESS = 0x19E8
  LOG_ARCHIVE_IN_PROGRESS = 0x19E9
  LOG_EPHEMERAL = 0x19EA
  LOG_NOT_ENOUGH_CONTAINERS = 0x19EB
  LOG_CLIENT_ALREADY_REGISTERED = 0x19EC
  LOG_CLIENT_NOT_REGISTERED = 0x19ED
  LOG_FULL_HANDLER_IN_PROGRESS = 0x19EE
  LOG_CONTAINER_READ_FAILED = 0x19EF
  LOG_CONTAINER_WRITE_FAILED = 0x19F0
  LOG_CONTAINER_OPEN_FAILED = 0x19F1
  LOG_CONTAINER_STATE_INVALID = 0x19F2
  LOG_STATE_INVALID = 0x19F3
  LOG_PINNED = 0x19F4
  LOG_METADATA_FLUSH_FAILED = 0x19F5
  LOG_INCONSISTENT_SECURITY = 0x19F6
  LOG_APPENDED_FLUSH_FAILED = 0x19F7
  LOG_PINNED_RESERVATION = 0x19F8
  INVALID_TRANSACTION = 0x1A2C
  TRANSACTION_NOT_ACTIVE = 0x1A2D
  TRANSACTION_REQUEST_NOT_VALID = 0x1A2E
  TRANSACTION_NOT_REQUESTED = 0x1A2F
  TRANSACTION_ALREADY_ABORTED = 0x1A30
  TRANSACTION_ALREADY_COMMITTED = 0x1A31
  TM_INITIALIZATION_FAILED = 0x1A32
  RESOURCEMANAGER_READ_ONLY = 0x1A33
  TRANSACTION_NOT_JOINED = 0x1A34
  TRANSACTION_SUPERIOR_EXISTS = 0x1A35
  CRM_PROTOCOL_ALREADY_EXISTS = 0x1A36
  TRANSACTION_PROPAGATION_FAILED = 0x1A37
  CRM_PROTOCOL_NOT_FOUND = 0x1A38
  TRANSACTION_INVALID_MARSHALL_BUFFER = 0x1A39
  CURRENT_TRANSACTION_NOT_VALID = 0x1A3A
  TRANSACTION_NOT_FOUND = 0x1A3B
  RESOURCEMANAGER_NOT_FOUND = 0x1A3C
  ENLISTMENT_NOT_FOUND = 0x1A3D
  TRANSACTIONMANAGER_NOT_FOUND = 0x1A3E
  TRANSACTIONMANAGER_NOT_ONLINE = 0x1A3F
  TRANSACTIONMANAGER_RECOVERY_NAME_COLLISION = 0x1A40
  TRANSACTION_NOT_ROOT = 0x1A41
  TRANSACTION_OBJECT_EXPIRED = 0x1A42
  TRANSACTION_RESPONSE_NOT_ENLISTED = 0x1A43
  TRANSACTION_RECORD_TOO_LONG = 0x1A44
  IMPLICIT_TRANSACTION_NOT_SUPPORTED = 0x1A45
  TRANSACTION_INTEGRITY_VIOLATED = 0x1A46
  TRANSACTIONMANAGER_IDENTITY_MISMATCH = 0x1A47
  RM_CANNOT_BE_FROZEN_FOR_SNAPSHOT = 0x1A48
  TRANSACTION_MUST_WRITETHROUGH = 0x1A49
  TRANSACTION_NO_SUPERIOR = 0x1A4A
  HEURISTIC_DAMAGE_POSSIBLE = 0x1A4B
  TRANSACTIONAL_CONFLICT = 0x1A90
  RM_NOT_ACTIVE = 0x1A91
  RM_METADATA_CORRUPT = 0x1A92
  DIRECTORY_NOT_RM = 0x1A93
  TRANSACTIONS_UNSUPPORTED_REMOTE = 0x1A95
  LOG_RESIZE_INVALID_SIZE = 0x1A96
  OBJECT_NO_LONGER_EXISTS = 0x1A97
  STREAM_MINIVERSION_NOT_FOUND = 0x1A98
  STREAM_MINIVERSION_NOT_VALID = 0x1A99
  MINIVERSION_INACCESSIBLE_FROM_SPECIFIED_TRANSACTION = 0x1A9A
  CANT_OPEN_MINIVERSION_WITH_MODIFY_INTENT = 0x1A9B
  CANT_CREATE_MORE_STREAM_MINIVERSIONS = 0x1A9C
  REMOTE_FILE_VERSION_MISMATCH = 0x1A9E
  HANDLE_NO_LONGER_VALID = 0x1A9F
  NO_TXF_METADATA = 0x1AA0
  LOG_CORRUPTION_DETECTED = 0x1AA1
  CANT_RECOVER_WITH_HANDLE_OPEN = 0x1AA2
  RM_DISCONNECTED = 0x1AA3
  ENLISTMENT_NOT_SUPERIOR = 0x1AA4
  RECOVERY_NOT_NEEDED = 0x1AA5
  RM_ALREADY_STARTED = 0x1AA6
  FILE_IDENTITY_NOT_PERSISTENT = 0x1AA7
  CANT_BREAK_TRANSACTIONAL_DEPENDENCY = 0x1AA8
  CANT_CROSS_RM_BOUNDARY = 0x1AA9
  TXF_DIR_NOT_EMPTY = 0x1AAA
  INDOUBT_TRANSACTIONS_EXIST = 0x1AAB
  TM_VOLATILE = 0x1AAC
  ROLLBACK_TIMER_EXPIRED = 0x1AAD
  TXF_ATTRIBUTE_CORRUPT = 0x1AAE
  EFS_NOT_ALLOWED_IN_TRANSACTION = 0x1AAF
  TRANSACTIONAL_OPEN_NOT_ALLOWED = 0x1AB0
  LOG_GROWTH_FAILED = 0x1AB1
  TRANSACTED_MAPPING_UNSUPPORTED_REMOTE = 0x1AB2
  TXF_METADATA_ALREADY_PRESENT = 0x1AB3
  TRANSACTION_SCOPE_CALLBACKS_NOT_SET = 0x1AB4
  TRANSACTION_REQUIRED_PROMOTION = 0x1AB5
  CANNOT_EXECUTE_FILE_IN_TRANSACTION = 0x1AB6
  TRANSACTIONS_NOT_FROZEN = 0x1AB7
  TRANSACTION_FREEZE_IN_PROGRESS = 0x1AB8
  NOT_SNAPSHOT_VOLUME = 0x1AB9
  NO_SAVEPOINT_WITH_OPEN_FILES = 0x1ABA
  DATA_LOST_REPAIR = 0x1ABB
  SPARSE_NOT_ALLOWED_IN_TRANSACTION = 0x1ABC
  TM_IDENTITY_MISMATCH = 0x1ABD
  FLOATED_SECTION = 0x1ABE
  CANNOT_ACCEPT_TRANSACTED_WORK = 0x1ABF
  CANNOT_ABORT_TRANSACTIONS = 0x1AC0
  BAD_CLUSTERS = 0x1AC1
  COMPRESSION_NOT_ALLOWED_IN_TRANSACTION = 0x1AC2
  VOLUME_DIRTY = 0x1AC3
  NO_LINK_TRACKING_IN_TRANSACTION = 0x1AC4
  OPERATION_NOT_SUPPORTED_IN_TRANSACTION = 0x1AC5
  EXPIRED_HANDLE = 0x1AC6
  TRANSACTION_NOT_ENLISTED = 0x1AC7
  CTX_WINSTATION_NAME_INVALID = 0x1B59
  CTX_INVALID_PD = 0x1B5A
  CTX_PD_NOT_FOUND = 0x1B5B
  CTX_WD_NOT_FOUND = 0x1B5C
  CTX_CANNOT_MAKE_EVENTLOG_ENTRY = 0x1B5D
  CTX_SERVICE_NAME_COLLISION = 0x1B5E
  CTX_CLOSE_PENDING = 0x1B5F
  CTX_NO_OUTBUF = 0x1B60
  CTX_MODEM_INF_NOT_FOUND = 0x1B61
  CTX_INVALID_MODEMNAME = 0x1B62
  CTX_MODEM_RESPONSE_ERROR = 0x1B63
  CTX_MODEM_RESPONSE_TIMEOUT = 0x1B64
  CTX_MODEM_RESPONSE_NO_CARRIER = 0x1B65
  CTX_MODEM_RESPONSE_NO_DIALTONE = 0x1B66
  CTX_MODEM_RESPONSE_BUSY = 0x1B67
  CTX_MODEM_RESPONSE_VOICE = 0x1B68
  CTX_TD_ERROR = 0x1B69
  CTX_WINSTATION_NOT_FOUND = 0x1B6E
  CTX_WINSTATION_ALREADY_EXISTS = 0x1B6F
  CTX_WINSTATION_BUSY = 0x1B70
  CTX_BAD_VIDEO_MODE = 0x1B71
  CTX_GRAPHICS_INVALID = 0x1B7B
  CTX_LOGON_DISABLED = 0x1B7D
  CTX_NOT_CONSOLE = 0x1B7E
  CTX_CLIENT_QUERY_TIMEOUT = 0x1B80
  CTX_CONSOLE_DISCONNECT = 0x1B81
  CTX_CONSOLE_CONNECT = 0x1B82
  CTX_SHADOW_DENIED = 0x1B84
  CTX_WINSTATION_ACCESS_DENIED = 0x1B85
  CTX_INVALID_WD = 0x1B89
  CTX_SHADOW_INVALID = 0x1B8A
  CTX_SHADOW_DISABLED = 0x1B8B
  CTX_CLIENT_LICENSE_IN_USE = 0x1B8C
  CTX_CLIENT_LICENSE_NOT_SET = 0x1B8D
  CTX_LICENSE_NOT_AVAILABLE = 0x1B8E
  CTX_LICENSE_CLIENT_INVALID = 0x1B8F
  CTX_LICENSE_EXPIRED = 0x1B90
  CTX_SHADOW_NOT_RUNNING = 0x1B91
  CTX_SHADOW_ENDED_BY_MODE_CHANGE = 0x1B92
  ACTIVATION_COUNT_EXCEEDED = 0x1B93
  CTX_WINSTATIONS_DISABLED = 0x1B94
  CTX_ENCRYPTION_LEVEL_REQUIRED = 0x1B95
  CTX_SESSION_IN_USE = 0x1B96
  CTX_NO_FORCE_LOGOFF = 0x1B97
  CTX_ACCOUNT_RESTRICTION = 0x1B98
  RDP_PROTOCOL_ERROR = 0x1B99
  CTX_CDM_CONNECT = 0x1B9A
  CTX_CDM_DISCONNECT = 0x1B9B
  CTX_SECURITY_LAYER_ERROR = 0x1B9C
  TS_INCOMPATIBLE_SESSIONS = 0x1B9D
  TS_VIDEO_SUBSYSTEM_ERROR = 0x1B9E
  FRS_ERR_INVALID_API_SEQUENCE = 0x1F41
  FRS_ERR_STARTING_SERVICE = 0x1F42
  FRS_ERR_STOPPING_SERVICE = 0x1F43
  FRS_ERR_INTERNAL_API = 0x1F44
  FRS_ERR_INTERNAL = 0x1F45
  FRS_ERR_SERVICE_COMM = 0x1F46
  FRS_ERR_INSUFFICIENT_PRIV = 0x1F47
  FRS_ERR_AUTHENTICATION = 0x1F48
  FRS_ERR_PARENT_INSUFFICIENT_PRIV = 0x1F49
  FRS_ERR_PARENT_AUTHENTICATION = 0x1F4A
  FRS_ERR_CHILD_TO_PARENT_COMM = 0x1F4B
  FRS_ERR_PARENT_TO_CHILD_COMM = 0x1F4C
  FRS_ERR_SYSVOL_POPULATE = 0x1F4D
  FRS_ERR_SYSVOL_POPULATE_TIMEOUT = 0x1F4E
  FRS_ERR_SYSVOL_IS_BUSY = 0x1F4F
  FRS_ERR_SYSVOL_DEMOTE = 0x1F50
  FRS_ERR_INVALID_SERVICE_PARAMETER = 0x1F51
  DS_NOT_INSTALLED = 0x2008
  DS_MEMBERSHIP_EVALUATED_LOCALLY = 0x2009
  DS_NO_ATTRIBUTE_OR_VALUE = 0x200A
  DS_INVALID_ATTRIBUTE_SYNTAX = 0x200B
  DS_ATTRIBUTE_TYPE_UNDEFINED = 0x200C
  DS_ATTRIBUTE_OR_VALUE_EXISTS = 0x200D
  DS_BUSY = 0x200E
  DS_UNAVAILABLE = 0x200F
  DS_NO_RIDS_ALLOCATED = 0x2010
  DS_NO_MORE_RIDS = 0x2011
  DS_INCORRECT_ROLE_OWNER = 0x2012
  DS_RIDMGR_INIT_ERROR = 0x2013
  DS_OBJ_CLASS_VIOLATION = 0x2014
  DS_CANT_ON_NON_LEAF = 0x2015
  DS_CANT_ON_RDN = 0x2016
  DS_CANT_MOD_OBJ_CLASS = 0x2017
  DS_CROSS_DOM_MOVE_ERROR = 0x2018
  DS_GC_NOT_AVAILABLE = 0x2019
  SHARED_POLICY = 0x201A
  POLICY_OBJECT_NOT_FOUND = 0x201B
  POLICY_ONLY_IN_DS = 0x201C
  PROMOTION_ACTIVE = 0x201D
  NO_PROMOTION_ACTIVE = 0x201E
  DS_OPERATIONS_ERROR = 0x2020
  DS_PROTOCOL_ERROR = 0x2021
  DS_TIMELIMIT_EXCEEDED = 0x2022
  DS_SIZELIMIT_EXCEEDED = 0x2023
  DS_ADMIN_LIMIT_EXCEEDED = 0x2024
  DS_COMPARE_FALSE = 0x2025
  DS_COMPARE_TRUE = 0x2026
  DS_AUTH_METHOD_NOT_SUPPORTED = 0x2027
  DS_STRONG_AUTH_REQUIRED = 0x2028
  DS_INAPPROPRIATE_AUTH = 0x2029
  DS_AUTH_UNKNOWN = 0x202A
  DS_REFERRAL = 0x202B
  DS_UNAVAILABLE_CRIT_EXTENSION = 0x202C
  DS_CONFIDENTIALITY_REQUIRED = 0x202D
  DS_INAPPROPRIATE_MATCHING = 0x202E
  DS_CONSTRAINT_VIOLATION = 0x202F
  DS_NO_SUCH_OBJECT = 0x2030
  DS_ALIAS_PROBLEM = 0x2031
  DS_INVALID_DN_SYNTAX = 0x2032
  DS_IS_LEAF = 0x2033
  DS_ALIAS_DEREF_PROBLEM = 0x2034
  DS_UNWILLING_TO_PERFORM = 0x2035
  DS_LOOP_DETECT = 0x2036
  DS_NAMING_VIOLATION = 0x2037
  DS_OBJECT_RESULTS_TOO_LARGE = 0x2038
  DS_AFFECTS_MULTIPLE_DSAS = 0x2039
  DS_SERVER_DOWN = 0x203A
  DS_LOCAL_ERROR = 0x203B
  DS_ENCODING_ERROR = 0x203C
  DS_DECODING_ERROR = 0x203D
  DS_FILTER_UNKNOWN = 0x203E
  DS_PARAM_ERROR = 0x203F
  DS_NOT_SUPPORTED = 0x2040
  DS_NO_RESULTS_RETURNED = 0x2041
  DS_CONTROL_NOT_FOUND = 0x2042
  DS_CLIENT_LOOP = 0x2043
  DS_REFERRAL_LIMIT_EXCEEDED = 0x2044
  DS_SORT_CONTROL_MISSING = 0x2045
  DS_OFFSET_RANGE_ERROR = 0x2046
  DS_ROOT_MUST_BE_NC = 0x206D
  DS_ADD_REPLICA_INHIBITED = 0x206E
  DS_ATT_NOT_DEF_IN_SCHEMA = 0x206F
  DS_MAX_OBJ_SIZE_EXCEEDED = 0x2070
  DS_OBJ_STRING_NAME_EXISTS = 0x2071
  DS_NO_RDN_DEFINED_IN_SCHEMA = 0x2072
  DS_RDN_DOESNT_MATCH_SCHEMA = 0x2073
  DS_NO_REQUESTED_ATTS_FOUND = 0x2074
  DS_USER_BUFFER_TO_SMALL = 0x2075
  DS_ATT_IS_NOT_ON_OBJ = 0x2076
  DS_ILLEGAL_MOD_OPERATION = 0x2077
  DS_OBJ_TOO_LARGE = 0x2078
  DS_BAD_INSTANCE_TYPE = 0x2079
  DS_MASTERDSA_REQUIRED = 0x207A
  DS_OBJECT_CLASS_REQUIRED = 0x207B
  DS_MISSING_REQUIRED_ATT = 0x207C
  DS_ATT_NOT_DEF_FOR_CLASS = 0x207D
  DS_ATT_ALREADY_EXISTS = 0x207E
  DS_CANT_ADD_ATT_VALUES = 0x2080
  DS_SINGLE_VALUE_CONSTRAINT = 0x2081
  DS_RANGE_CONSTRAINT = 0x2082
  DS_ATT_VAL_ALREADY_EXISTS = 0x2083
  DS_CANT_REM_MISSING_ATT = 0x2084
  DS_CANT_REM_MISSING_ATT_VAL = 0x2085
  DS_ROOT_CANT_BE_SUBREF = 0x2086
  DS_NO_CHAINING = 0x2087
  DS_NO_CHAINED_EVAL = 0x2088
  DS_NO_PARENT_OBJECT = 0x2089
  DS_PARENT_IS_AN_ALIAS = 0x208A
  DS_CANT_MIX_MASTER_AND_REPS = 0x208B
  DS_CHILDREN_EXIST = 0x208C
  DS_OBJ_NOT_FOUND = 0x208D
  DS_ALIASED_OBJ_MISSING = 0x208E
  DS_BAD_NAME_SYNTAX = 0x208F
  DS_ALIAS_POINTS_TO_ALIAS = 0x2090
  DS_CANT_DEREF_ALIAS = 0x2091
  DS_OUT_OF_SCOPE = 0x2092
  DS_CANT_DELETE_DSA_OBJ = 0x2094
  DS_GENERIC_ERROR = 0x2095
  DS_DSA_MUST_BE_INT_MASTER = 0x2096
  DS_CLASS_NOT_DSA = 0x2097
  DS_INSUFF_ACCESS_RIGHTS = 0x2098
  DS_ILLEGAL_SUPERIOR = 0x2099
  DS_ATTRIBUTE_OWNED_BY_SAM = 0x209A
  DS_NAME_TOO_MANY_PARTS = 0x209B
  DS_NAME_TOO_LONG = 0x209C
  DS_NAME_VALUE_TOO_LONG = 0x209D
  DS_NAME_UNPARSEABLE = 0x209E
  DS_NAME_TYPE_UNKNOWN = 0x209F
  DS_NOT_AN_OBJECT = 0x20A0
  DS_SEC_DESC_TOO_SHORT = 0x20A1
  DS_SEC_DESC_INVALID = 0x20A2
  DS_NO_DELETED_NAME = 0x20A3
  DS_SUBREF_MUST_HAVE_PARENT = 0x20A4
  DS_NCNAME_MUST_BE_NC = 0x20A5
  DS_CANT_ADD_SYSTEM_ONLY = 0x20A6
  DS_CLASS_MUST_BE_CONCRETE = 0x20A7
  DS_INVALID_DMD = 0x20A8
  DS_OBJ_GUID_EXISTS = 0x20A9
  DS_NOT_ON_BACKLINK = 0x20AA
  DS_NO_CROSSREF_FOR_NC = 0x20AB
  DS_SHUTTING_DOWN = 0x20AC
  DS_UNKNOWN_OPERATION = 0x20AD
  DS_INVALID_ROLE_OWNER = 0x20AE
  DS_COULDNT_CONTACT_FSMO = 0x20AF
  DS_CROSS_NC_DN_RENAME = 0x20B0
  DS_CANT_MOD_SYSTEM_ONLY = 0x20B1
  DS_REPLICATOR_ONLY = 0x20B2
  DS_OBJ_CLASS_NOT_DEFINED = 0x20B3
  DS_OBJ_CLASS_NOT_SUBCLASS = 0x20B4
  DS_NAME_REFERENCE_INVALID = 0x20B5
  DS_CROSS_REF_EXISTS = 0x20B6
  DS_CANT_DEL_MASTER_CROSSREF = 0x20B7
  DS_SUBTREE_NOTIFY_NOT_NC_HEAD = 0x20B8
  DS_NOTIFY_FILTER_TOO_COMPLEX = 0x20B9
  DS_DUP_RDN = 0x20BA
  DS_DUP_OID = 0x20BB
  DS_DUP_MAPI_ID = 0x20BC
  DS_DUP_SCHEMA_ID_GUID = 0x20BD
  DS_DUP_LDAP_DISPLAY_NAME = 0x20BE
  DS_SEMANTIC_ATT_TEST = 0x20BF
  DS_SYNTAX_MISMATCH = 0x20C0
  DS_EXISTS_IN_MUST_HAVE = 0x20C1
  DS_EXISTS_IN_MAY_HAVE = 0x20C2
  DS_NONEXISTENT_MAY_HAVE = 0x20C3
  DS_NONEXISTENT_MUST_HAVE = 0x20C4
  DS_AUX_CLS_TEST_FAIL = 0x20C5
  DS_NONEXISTENT_POSS_SUP = 0x20C6
  DS_SUB_CLS_TEST_FAIL = 0x20C7
  DS_BAD_RDN_ATT_ID_SYNTAX = 0x20C8
  DS_EXISTS_IN_AUX_CLS = 0x20C9
  DS_EXISTS_IN_SUB_CLS = 0x20CA
  DS_EXISTS_IN_POSS_SUP = 0x20CB
  DS_RECALCSCHEMA_FAILED = 0x20CC
  DS_TREE_DELETE_NOT_FINISHED = 0x20CD
  DS_CANT_DELETE = 0x20CE
  DS_ATT_SCHEMA_REQ_ID = 0x20CF
  DS_BAD_ATT_SCHEMA_SYNTAX = 0x20D0
  DS_CANT_CACHE_ATT = 0x20D1
  DS_CANT_CACHE_CLASS = 0x20D2
  DS_CANT_REMOVE_ATT_CACHE = 0x20D3
  DS_CANT_REMOVE_CLASS_CACHE = 0x20D4
  DS_CANT_RETRIEVE_DN = 0x20D5
  DS_MISSING_SUPREF = 0x20D6
  DS_CANT_RETRIEVE_INSTANCE = 0x20D7
  DS_CODE_INCONSISTENCY = 0x20D8
  DS_DATABASE_ERROR = 0x20D9
  DS_GOVERNSID_MISSING = 0x20DA
  DS_MISSING_EXPECTED_ATT = 0x20DB
  DS_NCNAME_MISSING_CR_REF = 0x20DC
  DS_SECURITY_CHECKING_ERROR = 0x20DD
  DS_SCHEMA_NOT_LOADED = 0x20DE
  DS_SCHEMA_ALLOC_FAILED = 0x20DF
  DS_ATT_SCHEMA_REQ_SYNTAX = 0x20E0
  DS_GCVERIFY_ERROR = 0x20E1
  DS_DRA_SCHEMA_MISMATCH = 0x20E2
  DS_CANT_FIND_DSA_OBJ = 0x20E3
  DS_CANT_FIND_EXPECTED_NC = 0x20E4
  DS_CANT_FIND_NC_IN_CACHE = 0x20E5
  DS_CANT_RETRIEVE_CHILD = 0x20E6
  DS_SECURITY_ILLEGAL_MODIFY = 0x20E7
  DS_CANT_REPLACE_HIDDEN_REC = 0x20E8
  DS_BAD_HIERARCHY_FILE = 0x20E9
  DS_BUILD_HIERARCHY_TABLE_FAILED = 0x20EA
  DS_CONFIG_PARAM_MISSING = 0x20EB
  DS_COUNTING_AB_INDICES_FAILED = 0x20EC
  DS_HIERARCHY_TABLE_MALLOC_FAILED = 0x20ED
  DS_INTERNAL_FAILURE = 0x20EE
  DS_UNKNOWN_ERROR = 0x20EF
  DS_ROOT_REQUIRES_CLASS_TOP = 0x20F0
  DS_REFUSING_FSMO_ROLES = 0x20F1
  DS_MISSING_FSMO_SETTINGS = 0x20F2
  DS_UNABLE_TO_SURRENDER_ROLES = 0x20F3
  DS_DRA_GENERIC = 0x20F4
  DS_DRA_INVALID_PARAMETER = 0x20F5
  DS_DRA_BUSY = 0x20F6
  DS_DRA_BAD_DN = 0x20F7
  DS_DRA_BAD_NC = 0x20F8
  DS_DRA_DN_EXISTS = 0x20F9
  DS_DRA_INTERNAL_ERROR = 0x20FA
  DS_DRA_INCONSISTENT_DIT = 0x20FB
  DS_DRA_CONNECTION_FAILED = 0x20FC
  DS_DRA_BAD_INSTANCE_TYPE = 0x20FD
  DS_DRA_OUT_OF_MEM = 0x20FE
  DS_DRA_MAIL_PROBLEM = 0x20FF
  DS_DRA_REF_ALREADY_EXISTS = 0x2100
  DS_DRA_REF_NOT_FOUND = 0x2101
  DS_DRA_OBJ_IS_REP_SOURCE = 0x2102
  DS_DRA_DB_ERROR = 0x2103
  DS_DRA_NO_REPLICA = 0x2104
  DS_DRA_ACCESS_DENIED = 0x2105
  DS_DRA_NOT_SUPPORTED = 0x2106
  DS_DRA_RPC_CANCELLED = 0x2107
  DS_DRA_SOURCE_DISABLED = 0x2108
  DS_DRA_SINK_DISABLED = 0x2109
  DS_DRA_NAME_COLLISION = 0x210A
  DS_DRA_SOURCE_REINSTALLED = 0x210B
  DS_DRA_MISSING_PARENT = 0x210C
  DS_DRA_PREEMPTED = 0x210D
  DS_DRA_ABANDON_SYNC = 0x210E
  DS_DRA_SHUTDOWN = 0x210F
  DS_DRA_INCOMPATIBLE_PARTIAL_SET = 0x2110
  DS_DRA_SOURCE_IS_PARTIAL_REPLICA = 0x2111
  DS_DRA_EXTN_CONNECTION_FAILED = 0x2112
  DS_INSTALL_SCHEMA_MISMATCH = 0x2113
  DS_DUP_LINK_ID = 0x2114
  DS_NAME_RESOLVING = 0x2115
  DS_NAME_NOT_FOUND = 0x2116
  DS_NAME_ERROR_NOT_UNIQUE = 0x2117
  DS_NAME_NO_MAPPING = 0x2118
  DS_NAME_DOMAIN_ONLY = 0x2119
  DS_NAME_NO_SYNTACTICAL_MAPPING = 0x211A
  DS_CONSTRUCTED_ATT_MOD = 0x211B
  DS_WRONG_OM_OBJ_CLASS = 0x211C
  DS_DRA_REPL_PENDING = 0x211D
  DS_DS_REQUIRED = 0x211E
  DS_INVALID_LDAP_DISPLAY_NAME = 0x211F
  DS_NON_BASE_SEARCH = 0x2120
  DS_CANT_RETRIEVE_ATTS = 0x2121
  DS_BACKLINK_WITHOUT_LINK = 0x2122
  DS_EPOCH_MISMATCH = 0x2123
  DS_SRC_NAME_MISMATCH = 0x2124
  DS_SRC_AND_DST_NC_IDENTICAL = 0x2125
  DS_DST_NC_MISMATCH = 0x2126
  DS_NOT_AUTHORITIVE_FOR_DST_NC = 0x2127
  DS_SRC_GUID_MISMATCH = 0x2128
  DS_CANT_MOVE_DELETED_OBJECT = 0x2129
  DS_PDC_OPERATION_IN_PROGRESS = 0x212A
  DS_CROSS_DOMAIN_CLEANUP_REQD = 0x212B
  DS_ILLEGAL_XDOM_MOVE_OPERATION = 0x212C
  DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS = 0x212D
  DS_NC_MUST_HAVE_NC_PARENT = 0x212E
  DS_CR_IMPOSSIBLE_TO_VALIDATE = 0x212F
  DS_DST_DOMAIN_NOT_NATIVE = 0x2130
  DS_MISSING_INFRASTRUCTURE_CONTAINER = 0x2131
  DS_CANT_MOVE_ACCOUNT_GROUP = 0x2132
  DS_CANT_MOVE_RESOURCE_GROUP = 0x2133
  DS_INVALID_SEARCH_FLAG = 0x2134
  DS_NO_TREE_DELETE_ABOVE_NC = 0x2135
  DS_COULDNT_LOCK_TREE_FOR_DELETE = 0x2136
  DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE = 0x2137
  DS_SAM_INIT_FAILURE = 0x2138
  DS_SENSITIVE_GROUP_VIOLATION = 0x2139
  DS_CANT_MOD_PRIMARYGROUPID = 0x213A
  DS_ILLEGAL_BASE_SCHEMA_MOD = 0x213B
  DS_NONSAFE_SCHEMA_CHANGE = 0x213C
  DS_SCHEMA_UPDATE_DISALLOWED = 0x213D
  DS_CANT_CREATE_UNDER_SCHEMA = 0x213E
  DS_INSTALL_NO_SRC_SCH_VERSION = 0x213F
  DS_INSTALL_NO_SCH_VERSION_IN_INIFILE = 0x2140
  DS_INVALID_GROUP_TYPE = 0x2141
  DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN = 0x2142
  DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN = 0x2143
  DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER = 0x2144
  DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER = 0x2145
  DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER = 0x2146
  DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER = 0x2147
  DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER = 0x2148
  DS_HAVE_PRIMARY_MEMBERS = 0x2149
  DS_STRING_SD_CONVERSION_FAILED = 0x214A
  DS_NAMING_MASTER_GC = 0x214B
  DS_LOOKUP_FAILURE = 0x214C
  DS_COULDNT_UPDATE_SPNS = 0x214D
  DS_CANT_RETRIEVE_SD = 0x214E
  DS_KEY_NOT_UNIQUE = 0x214F
  DS_WRONG_LINKED_ATT_SYNTAX = 0x2150
  DS_SAM_NEED_BOOTKEY_PASSWORD = 0x2151
  DS_SAM_NEED_BOOTKEY_FLOPPY = 0x2152
  DS_CANT_START = 0x2153
  DS_INIT_FAILURE = 0x2154
  DS_NO_PKT_PRIVACY_ON_CONNECTION = 0x2155
  DS_SOURCE_DOMAIN_IN_FOREST = 0x2156
  DS_DESTINATION_DOMAIN_NOT_IN_FOREST = 0x2157
  DS_DESTINATION_AUDITING_NOT_ENABLED = 0x2158
  DS_CANT_FIND_DC_FOR_SRC_DOMAIN = 0x2159
  DS_SRC_OBJ_NOT_GROUP_OR_USER = 0x215A
  DS_SRC_SID_EXISTS_IN_FOREST = 0x215B
  DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH = 0x215C
  SAM_INIT_FAILURE = 0x215D
  DS_DRA_SCHEMA_INFO_SHIP = 0x215E
  DS_DRA_SCHEMA_CONFLICT = 0x215F
  DS_DRA_EARLIER_SCHEMA_CONLICT = 0x2160
  DS_DRA_OBJ_NC_MISMATCH = 0x2161
  DS_NC_STILL_HAS_DSAS = 0x2162
  DS_GC_REQUIRED = 0x2163
  DS_LOCAL_MEMBER_OF_LOCAL_ONLY = 0x2164
  DS_NO_FPO_IN_UNIVERSAL_GROUPS = 0x2165
  DS_CANT_ADD_TO_GC = 0x2166
  DS_NO_CHECKPOINT_WITH_PDC = 0x2167
  DS_SOURCE_AUDITING_NOT_ENABLED = 0x2168
  DS_CANT_CREATE_IN_NONDOMAIN_NC = 0x2169
  DS_INVALID_NAME_FOR_SPN = 0x216A
  DS_FILTER_USES_CONTRUCTED_ATTRS = 0x216B
  DS_UNICODEPWD_NOT_IN_QUOTES = 0x216C
  DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED = 0x216D
  DS_MUST_BE_RUN_ON_DST_DC = 0x216E
  DS_SRC_DC_MUST_BE_SP4_OR_GREATER = 0x216F
  DS_CANT_TREE_DELETE_CRITICAL_OBJ = 0x2170
  DS_INIT_FAILURE_CONSOLE = 0x2171
  DS_SAM_INIT_FAILURE_CONSOLE = 0x2172
  DS_FOREST_VERSION_TOO_HIGH = 0x2173
  DS_DOMAIN_VERSION_TOO_HIGH = 0x2174
  DS_FOREST_VERSION_TOO_LOW = 0x2175
  DS_DOMAIN_VERSION_TOO_LOW = 0x2176
  DS_INCOMPATIBLE_VERSION = 0x2177
  DS_LOW_DSA_VERSION = 0x2178
  DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN = 0x2179
  DS_NOT_SUPPORTED_SORT_ORDER = 0x217A
  DS_NAME_NOT_UNIQUE = 0x217B
  DS_MACHINE_ACCOUNT_CREATED_PRENT4 = 0x217C
  DS_OUT_OF_VERSION_STORE = 0x217D
  DS_INCOMPATIBLE_CONTROLS_USED = 0x217E
  DS_NO_REF_DOMAIN = 0x217F
  DS_RESERVED_LINK_ID = 0x2180
  DS_LINK_ID_NOT_AVAILABLE = 0x2181
  DS_AG_CANT_HAVE_UNIVERSAL_MEMBER = 0x2182
  DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE = 0x2183
  DS_NO_OBJECT_MOVE_IN_SCHEMA_NC = 0x2184
  DS_MODIFYDN_DISALLOWED_BY_FLAG = 0x2185
  DS_MODIFYDN_WRONG_GRANDPARENT = 0x2186
  DS_NAME_TRUST_REFERRAL = 0x2187
  NOT_SUPPORTED_ON_STANDARD_SERVER = 0x2188
  DS_CANT_ACCESS_REMOTE_PART_OF_AD = 0x2189
  DS_CR_IMPOSSIBLE_TO_VALIDATE_V2 = 0x218A
  DS_THREAD_LIMIT_EXCEEDED = 0x218B
  DS_NOT_CLOSEST = 0x218C
  DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF = 0x218D
  DS_SINGLE_USER_MODE_FAILED = 0x218E
  DS_NTDSCRIPT_SYNTAX_ERROR = 0x218F
  DS_NTDSCRIPT_PROCESS_ERROR = 0x2190
  DS_DIFFERENT_REPL_EPOCHS = 0x2191
  DS_DRS_EXTENSIONS_CHANGED = 0x2192
  DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR = 0x2193
  DS_NO_MSDS_INTID = 0x2194
  DS_DUP_MSDS_INTID = 0x2195
  DS_EXISTS_IN_RDNATTID = 0x2196
  DS_AUTHORIZATION_FAILED = 0x2197
  DS_INVALID_SCRIPT = 0x2198
  DS_REMOTE_CROSSREF_OP_FAILED = 0x2199
  DS_CROSS_REF_BUSY = 0x219A
  DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN = 0x219B
  DS_CANT_DEMOTE_WITH_WRITEABLE_NC = 0x219C
  DS_DUPLICATE_ID_FOUND = 0x219D
  DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT = 0x219E
  DS_GROUP_CONVERSION_ERROR = 0x219F
  DS_CANT_MOVE_APP_BASIC_GROUP = 0x21A0
  DS_CANT_MOVE_APP_QUERY_GROUP = 0x21A1
  DS_ROLE_NOT_VERIFIED = 0x21A2
  DS_WKO_CONTAINER_CANNOT_BE_SPECIAL = 0x21A3
  DS_DOMAIN_RENAME_IN_PROGRESS = 0x21A4
  DS_EXISTING_AD_CHILD_NC = 0x21A5
  DS_REPL_LIFETIME_EXCEEDED = 0x21A6
  DS_DISALLOWED_IN_SYSTEM_CONTAINER = 0x21A7
  DS_LDAP_SEND_QUEUE_FULL = 0x21A8
  DS_DRA_OUT_SCHEDULE_WINDOW = 0x21A9
  DS_POLICY_NOT_KNOWN = 0x21AA
  NO_SITE_SETTINGS_OBJECT = 0x21AB
  NO_SECRETS = 0x21AC
  NO_WRITABLE_DC_FOUND = 0x21AD
  DS_NO_SERVER_OBJECT = 0x21AE
  DS_NO_NTDSA_OBJECT = 0x21AF
  DS_NON_ASQ_SEARCH = 0x21B0
  DS_AUDIT_FAILURE = 0x21B1
  DS_INVALID_SEARCH_FLAG_SUBTREE = 0x21B2
  DS_INVALID_SEARCH_FLAG_TUPLE = 0x21B3
  DS_HIERARCHY_TABLE_TOO_DEEP = 0x21B4
  DS_DRA_CORRUPT_UTD_VECTOR = 0x21B5
  DS_DRA_SECRETS_DENIED = 0x21B6
  DS_RESERVED_MAPI_ID = 0x21B7
  DS_MAPI_ID_NOT_AVAILABLE = 0x21B8
  DS_DRA_MISSING_KRBTGT_SECRET = 0x21B9
  DS_DOMAIN_NAME_EXISTS_IN_FOREST = 0x21BA
  DS_FLAT_NAME_EXISTS_IN_FOREST = 0x21BB
  INVALID_USER_PRINCIPAL_NAME = 0x21BC
  DS_OID_MAPPED_GROUP_CANT_HAVE_MEMBERS = 0x21BD
  DS_OID_NOT_FOUND = 0x21BE
  DS_DRA_RECYCLED_TARGET = 0x21BF
  DNS_RCODE_FORMAT_ERROR = 0x2329
  DNS_RCODE_SERVER_FAILURE = 0x232A
  DNS_RCODE_NAME_ERROR = 0x232B
  DNS_RCODE_NOT_IMPLEMENTED = 0x232C
  DNS_RCODE_REFUSED = 0x232D
  DNS_RCODE_YXDOMAIN = 0x232E
  DNS_RCODE_YXRRSET = 0x232F
  DNS_RCODE_NXRRSET = 0x2330
  DNS_RCODE_NOTAUTH = 0x2331
  DNS_RCODE_NOTZONE = 0x2332
  DNS_RCODE_BADSIG = 0x2338
  DNS_RCODE_BADKEY = 0x2339
  DNS_RCODE_BADTIME = 0x233A
  DNS_INFO_NO_RECORDS = 0x251D
  DNS_BAD_PACKET = 0x251E
  DNS_NO_PACKET = 0x251F
  DNS_RCODE = 0x2520
  DNS_UNSECURE_PACKET = 0x2521
  DNS_INVALID_TYPE = 0x254F
  DNS_INVALID_IP_ADDRESS = 0x2550
  DNS_INVALID_PROPERTY = 0x2551
  DNS_TRY_AGAIN_LATER = 0x2552
  DNS_NOT_UNIQUE = 0x2553
  DNS_NON_RFC_NAME = 0x2554
  DNS_STATUS_FQDN = 0x2555
  DNS_STATUS_DOTTED_NAME = 0x2556
  DNS_STATUS_SINGLE_PART_NAME = 0x2557
  DNS_INVALID_NAME_CHAR = 0x2558
  DNS_NUMERIC_NAME = 0x2559
  DNS_NOT_ALLOWED_ON_ROOT_SERVER = 0x255A
  DNS_NOT_ALLOWED_UNDER_DELEGATION = 0x255B
  DNS_CANNOT_FIND_ROOT_HINTS = 0x255C
  DNS_INCONSISTENT_ROOT_HINTS = 0x255D
  DNS_DWORD_VALUE_TOO_SMALL = 0x255E
  DNS_DWORD_VALUE_TOO_LARGE = 0x255F
  DNS_BACKGROUND_LOADING = 0x2560
  DNS_NOT_ALLOWED_ON_RODC = 0x2561
  DNS_NOT_ALLOWED_UNDER_DNAME = 0x2562
  DNS_DELEGATION_REQUIRED = 0x2563
  DNS_INVALID_POLICY_TABLE = 0x2564
  DNS_ZONE_DOES_NOT_EXIST = 0x2581
  DNS_NO_ZONE_INFO = 0x2582
  DNS_INVALID_ZONE_OPERATION = 0x2583
  DNS_ZONE_CONFIGURATION_ERROR = 0x2584
  DNS_ZONE_HAS_NO_SOA_RECORD = 0x2585
  DNS_ZONE_HAS_NO_NS_RECORDS = 0x2586
  DNS_ZONE_LOCKED = 0x2587
  DNS_ZONE_CREATION_FAILED = 0x2588
  DNS_ZONE_ALREADY_EXISTS = 0x2589
  DNS_AUTOZONE_ALREADY_EXISTS = 0x258A
  DNS_INVALID_ZONE_TYPE = 0x258B
  DNS_SECONDARY_REQUIRES_MASTER_IP = 0x258C
  DNS_ZONE_NOT_SECONDARY = 0x258D
  DNS_NEED_SECONDARY_ADDRESSES = 0x258E
  DNS_WINS_INIT_FAILED = 0x258F
  DNS_NEED_WINS_SERVERS = 0x2590
  DNS_NBSTAT_INIT_FAILED = 0x2591
  DNS_SOA_DELETE_INVALID = 0x2592
  DNS_FORWARDER_ALREADY_EXISTS = 0x2593
  DNS_ZONE_REQUIRES_MASTER_IP = 0x2594
  DNS_ZONE_IS_SHUTDOWN = 0x2595
  DNS_PRIMARY_REQUIRES_DATAFILE = 0x25B3
  DNS_INVALID_DATAFILE_NAME = 0x25B4
  DNS_DATAFILE_OPEN_FAILURE = 0x25B5
  DNS_FILE_WRITEBACK_FAILED = 0x25B6
  DNS_DATAFILE_PARSING = 0x25B7
  DNS_RECORD_DOES_NOT_EXIST = 0x25E5
  DNS_RECORD_FORMAT = 0x25E6
  DNS_NODE_CREATION_FAILED = 0x25E7
  DNS_UNKNOWN_RECORD_TYPE = 0x25E8
  DNS_RECORD_TIMED_OUT = 0x25E9
  DNS_NAME_NOT_IN_ZONE = 0x25EA
  DNS_CNAME_LOOP = 0x25EB
  DNS_NODE_IS_CNAME = 0x25EC
  DNS_CNAME_COLLISION = 0x25ED
  DNS_RECORD_ONLY_AT_ZONE_ROOT = 0x25EE
  DNS_RECORD_ALREADY_EXISTS = 0x25EF
  DNS_SECONDARY_DATA = 0x25F0
  DNS_NO_CREATE_CACHE_DATA = 0x25F1
  DNS_NAME_DOES_NOT_EXIST = 0x25F2
  DNS_WARNING_PTR_CREATE_FAILED = 0x25F3
  DNS_WARNING_DOMAIN_UNDELETED = 0x25F4
  DNS_DS_UNAVAILABLE = 0x25F5
  DNS_DS_ZONE_ALREADY_EXISTS = 0x25F6
  DNS_NO_BOOTFILE_IF_DS_ZONE = 0x25F7
  DNS_NODE_IS_DNAME = 0x25F8
  DNS_DNAME_COLLISION = 0x25F9
  DNS_ALIAS_LOOP = 0x25FA
  DNS_INFO_AXFR_COMPLETE = 0x2617
  DNS_AXFR = 0x2618
  DNS_INFO_ADDED_LOCAL_WINS = 0x2619
  DNS_STATUS_CONTINUE_NEEDED = 0x2649
  DNS_NO_TCPIP = 0x267B
  DNS_NO_DNS_SERVERS = 0x267C
  DNS_DP_DOES_NOT_EXIST = 0x26AD
  DNS_DP_ALREADY_EXISTS = 0x26AE
  DNS_DP_NOT_ENLISTED = 0x26AF
  DNS_DP_ALREADY_ENLISTED = 0x26B0
  DNS_DP_NOT_AVAILABLE = 0x26B1
  DNS_DP_FSMO_ERROR = 0x26B2
  WSAEINTR = 0x2714
  WSAEBADF = 0x2719
  WSAEACCES = 0x271D
  WSAEFAULT = 0x271E
  WSAEINVAL = 0x2726
  WSAEMFILE = 0x2728
  WSAEWOULDBLOCK = 0x2733
  WSAEINPROGRESS = 0x2734
  WSAEALREADY = 0x2735
  WSAENOTSOCK = 0x2736
  WSAEDESTADDRREQ = 0x2737
  WSAEMSGSIZE = 0x2738
  WSAEPROTOTYPE = 0x2739
  WSAENOPROTOOPT = 0x273A
  WSAEPROTONOSUPPORT = 0x273B
  WSAESOCKTNOSUPPORT = 0x273C
  WSAEOPNOTSUPP = 0x273D
  WSAEPFNOSUPPORT = 0x273E
  WSAEAFNOSUPPORT = 0x273F
  WSAEADDRINUSE = 0x2740
  WSAEADDRNOTAVAIL = 0x2741
  WSAENETDOWN = 0x2742
  WSAENETUNREACH = 0x2743
  WSAENETRESET = 0x2744
  WSAECONNABORTED = 0x2745
  WSAECONNRESET = 0x2746
  WSAENOBUFS = 0x2747
  WSAEISCONN = 0x2748
  WSAENOTCONN = 0x2749
  WSAESHUTDOWN = 0x274A
  WSAETOOMANYREFS = 0x274B
  WSAETIMEDOUT = 0x274C
  WSAECONNREFUSED = 0x274D
  WSAELOOP = 0x274E
  WSAENAMETOOLONG = 0x274F
  WSAEHOSTDOWN = 0x2750
  WSAEHOSTUNREACH = 0x2751
  WSAENOTEMPTY = 0x2752
  WSAEPROCLIM = 0x2753
  WSAEUSERS = 0x2754
  WSAEDQUOT = 0x2755
  WSAESTALE = 0x2756
  WSAEREMOTE = 0x2757
  WSASYSNOTREADY = 0x276B
  WSAVERNOTSUPPORTED = 0x276C
  WSANOTINITIALISED = 0x276D
  WSAEDISCON = 0x2775
  WSAENOMORE = 0x2776
  WSAECANCELLED = 0x2777
  WSAEINVALIDPROCTABLE = 0x2778
  WSAEINVALIDPROVIDER = 0x2779
  WSAEPROVIDERFAILEDINIT = 0x277A
  WSASYSCALLFAILURE = 0x277B
  WSASERVICE_NOT_FOUND = 0x277C
  WSATYPE_NOT_FOUND = 0x277D
  WSA_E_NO_MORE = 0x277E
  WSA_E_CANCELLED = 0x277F
  WSAEREFUSED = 0x2780
  WSAHOST_NOT_FOUND = 0x2AF9
  WSATRY_AGAIN = 0x2AFA
  WSANO_RECOVERY = 0x2AFB
  WSANO_DATA = 0x2AFC
  WSA_QOS_RECEIVERS = 0x2AFD
  WSA_QOS_SENDERS = 0x2AFE
  WSA_QOS_NO_SENDERS = 0x2AFF
  WSA_QOS_NO_RECEIVERS = 0x2B00
  WSA_QOS_REQUEST_CONFIRMED = 0x2B01
  WSA_QOS_ADMISSION_FAILURE = 0x2B02
  WSA_QOS_POLICY_FAILURE = 0x2B03
  WSA_QOS_BAD_STYLE = 0x2B04
  WSA_QOS_BAD_OBJECT = 0x2B05
  WSA_QOS_TRAFFIC_CTRL_ERROR = 0x2B06
  WSA_QOS_GENERIC_ERROR = 0x2B07
  WSA_QOS_ESERVICETYPE = 0x2B08
  WSA_QOS_EFLOWSPEC = 0x2B09
  WSA_QOS_EPROVSPECBUF = 0x2B0A
  WSA_QOS_EFILTERSTYLE = 0x2B0B
  WSA_QOS_EFILTERTYPE = 0x2B0C
  WSA_QOS_EFILTERCOUNT = 0x2B0D
  WSA_QOS_EOBJLENGTH = 0x2B0E
  WSA_QOS_EFLOWCOUNT = 0x2B0F
  WSA_QOS_EUNKNOWNPSOBJ = 0x2B10
  WSA_QOS_EPOLICYOBJ = 0x2B11
  WSA_QOS_EFLOWDESC = 0x2B12
  WSA_QOS_EPSFLOWSPEC = 0x2B13
  WSA_QOS_EPSFILTERSPEC = 0x2B14
  WSA_QOS_ESDMODEOBJ = 0x2B15
  WSA_QOS_ESHAPERATEOBJ = 0x2B16
  WSA_QOS_RESERVED_PETYPE = 0x2B17
  IPSEC_QM_POLICY_EXISTS = 0x32C8
  IPSEC_QM_POLICY_NOT_FOUND = 0x32C9
  IPSEC_QM_POLICY_IN_USE = 0x32CA
  IPSEC_MM_POLICY_EXISTS = 0x32CB
  IPSEC_MM_POLICY_NOT_FOUND = 0x32CC
  IPSEC_MM_POLICY_IN_USE = 0x32CD
  IPSEC_MM_FILTER_EXISTS = 0x32CE
  IPSEC_MM_FILTER_NOT_FOUND = 0x32CF
  IPSEC_TRANSPORT_FILTER_EXISTS = 0x32D0
  IPSEC_TRANSPORT_FILTER_NOT_FOUND = 0x32D1
  IPSEC_MM_AUTH_EXISTS = 0x32D2
  IPSEC_MM_AUTH_NOT_FOUND = 0x32D3
  IPSEC_MM_AUTH_IN_USE = 0x32D4
  IPSEC_DEFAULT_MM_POLICY_NOT_FOUND = 0x32D5
  IPSEC_DEFAULT_MM_AUTH_NOT_FOUND = 0x32D6
  IPSEC_DEFAULT_QM_POLICY_NOT_FOUND = 0x32D7
  IPSEC_TUNNEL_FILTER_EXISTS = 0x32D8
  IPSEC_TUNNEL_FILTER_NOT_FOUND = 0x32D9
  IPSEC_MM_FILTER_PENDING_DELETION = 0x32DA
  IPSEC_TRANSPORT_FILTER_PENDING_DELETION = 0x32DB
  IPSEC_TUNNEL_FILTER_PENDING_DELETION = 0x32DC
  IPSEC_MM_POLICY_PENDING_DELETION = 0x32DD
  IPSEC_MM_AUTH_PENDING_DELETION = 0x32DE
  IPSEC_QM_POLICY_PENDING_DELETION = 0x32DF
  WARNING_IPSEC_MM_POLICY_PRUNED = 0x32E0
  WARNING_IPSEC_QM_POLICY_PRUNED = 0x32E1
  IPSEC_IKE_AUTH_FAIL = 0x35E9
  IPSEC_IKE_ATTRIB_FAIL = 0x35EA
  IPSEC_IKE_NEGOTIATION_PENDING = 0x35EB
  IPSEC_IKE_GENERAL_PROCESSING_ERROR = 0x35EC
  IPSEC_IKE_TIMED_OUT = 0x35ED
  IPSEC_IKE_NO_CERT = 0x35EE
  IPSEC_IKE_SA_DELETED = 0x35EF
  IPSEC_IKE_SA_REAPED = 0x35F0
  IPSEC_IKE_MM_ACQUIRE_DROP = 0x35F1
  IPSEC_IKE_QM_ACQUIRE_DROP = 0x35F2
  IPSEC_IKE_QUEUE_DROP_MM = 0x35F3
  IPSEC_IKE_QUEUE_DROP_NO_MM = 0x35F4
  IPSEC_IKE_DROP_NO_RESPONSE = 0x35F5
  IPSEC_IKE_MM_DELAY_DROP = 0x35F6
  IPSEC_IKE_QM_DELAY_DROP = 0x35F7
  IPSEC_IKE_ERROR = 0x35F8
  IPSEC_IKE_CRL_FAILED = 0x35F9
  IPSEC_IKE_INVALID_KEY_USAGE = 0x35FA
  IPSEC_IKE_INVALID_CERT_TYPE = 0x35FB
  IPSEC_IKE_NO_PRIVATE_KEY = 0x35FC
  IPSEC_IKE_DH_FAIL = 0x35FE
  IPSEC_IKE_CRITICAL_PAYLOAD_NOT_RECOGNIZED = 0x35FF
  IPSEC_IKE_INVALID_HEADER = 0x3600
  IPSEC_IKE_NO_POLICY = 0x3601
  IPSEC_IKE_INVALID_SIGNATURE = 0x3602
  IPSEC_IKE_KERBEROS_ERROR = 0x3603
  IPSEC_IKE_NO_PUBLIC_KEY = 0x3604
  IPSEC_IKE_PROCESS_ERR = 0x3605
  IPSEC_IKE_PROCESS_ERR_SA = 0x3606
  IPSEC_IKE_PROCESS_ERR_PROP = 0x3607
  IPSEC_IKE_PROCESS_ERR_TRANS = 0x3608
  IPSEC_IKE_PROCESS_ERR_KE = 0x3609
  IPSEC_IKE_PROCESS_ERR_ID = 0x360A
  IPSEC_IKE_PROCESS_ERR_CERT = 0x360B
  IPSEC_IKE_PROCESS_ERR_CERT_REQ = 0x360C
  IPSEC_IKE_PROCESS_ERR_HASH = 0x360D
  IPSEC_IKE_PROCESS_ERR_SIG = 0x360E
  IPSEC_IKE_PROCESS_ERR_NONCE = 0x360F
  IPSEC_IKE_PROCESS_ERR_NOTIFY = 0x3610
  IPSEC_IKE_PROCESS_ERR_DELETE = 0x3611
  IPSEC_IKE_PROCESS_ERR_VENDOR = 0x3612
  IPSEC_IKE_INVALID_PAYLOAD = 0x3613
  IPSEC_IKE_LOAD_SOFT_SA = 0x3614
  IPSEC_IKE_SOFT_SA_TORN_DOWN = 0x3615
  IPSEC_IKE_INVALID_COOKIE = 0x3616
  IPSEC_IKE_NO_PEER_CERT = 0x3617
  IPSEC_IKE_PEER_CRL_FAILED = 0x3618
  IPSEC_IKE_POLICY_CHANGE = 0x3619
  IPSEC_IKE_NO_MM_POLICY = 0x361A
  IPSEC_IKE_NOTCBPRIV = 0x361B
  IPSEC_IKE_SECLOADFAIL = 0x361C
  IPSEC_IKE_FAILSSPINIT = 0x361D
  IPSEC_IKE_FAILQUERYSSP = 0x361E
  IPSEC_IKE_SRVACQFAIL = 0x361F
  IPSEC_IKE_SRVQUERYCRED = 0x3620
  IPSEC_IKE_GETSPIFAIL = 0x3621
  IPSEC_IKE_INVALID_FILTER = 0x3622
  IPSEC_IKE_OUT_OF_MEMORY = 0x3623
  IPSEC_IKE_ADD_UPDATE_KEY_FAILED = 0x3624
  IPSEC_IKE_INVALID_POLICY = 0x3625
  IPSEC_IKE_UNKNOWN_DOI = 0x3626
  IPSEC_IKE_INVALID_SITUATION = 0x3627
  IPSEC_IKE_DH_FAILURE = 0x3628
  IPSEC_IKE_INVALID_GROUP = 0x3629
  IPSEC_IKE_ENCRYPT = 0x362A
  IPSEC_IKE_DECRYPT = 0x362B
  IPSEC_IKE_POLICY_MATCH = 0x362C
  IPSEC_IKE_UNSUPPORTED_ID = 0x362D
  IPSEC_IKE_INVALID_HASH = 0x362E
  IPSEC_IKE_INVALID_HASH_ALG = 0x362F
  IPSEC_IKE_INVALID_HASH_SIZE = 0x3630
  IPSEC_IKE_INVALID_ENCRYPT_ALG = 0x3631
  IPSEC_IKE_INVALID_AUTH_ALG = 0x3632
  IPSEC_IKE_INVALID_SIG = 0x3633
  IPSEC_IKE_LOAD_FAILED = 0x3634
  IPSEC_IKE_RPC_DELETE = 0x3635
  IPSEC_IKE_BENIGN_REINIT = 0x3636
  IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY = 0x3637
  IPSEC_IKE_QM_LIMIT_REAP = 0x3638
  IPSEC_IKE_INVALID_CERT_KEYLEN = 0x3639
  IPSEC_IKE_MM_LIMIT = 0x363A
  IPSEC_IKE_NEGOTIATION_DISABLED = 0x363B
  IPSEC_IKE_QM_LIMIT = 0x363C
  IPSEC_IKE_MM_EXPIRED = 0x363D
  IPSEC_IKE_PEER_MM_ASSUMED_INVALID = 0x363E
  IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH = 0x363F
  IPSEC_IKE_UNEXPECTED_MESSAGE_ID = 0x3640
  IPSEC_IKE_INVALID_AUTH_PAYLOAD = 0x3641
  IPSEC_IKE_DOS_COOKIE_SENT = 0x3642
  IPSEC_IKE_SHUTTING_DOWN = 0x3643
  IPSEC_IKE_CGA_AUTH_FAILED = 0x3644
  IPSEC_IKE_PROCESS_ERR_NATOA = 0x3645
  IPSEC_IKE_INVALID_MM_FOR_QM = 0x3646
  IPSEC_IKE_QM_EXPIRED = 0x3647
  IPSEC_IKE_TOO_MANY_FILTERS = 0x3648
  IPSEC_IKE_NEG_STATUS_END = 0x3649
  IPSEC_IKE_KILL_DUMMY_NAP_TUNNEL = 0x364A
  IPSEC_IKE_INNER_IP_ASSIGNMENT_FAILURE = 0x364B
  IPSEC_IKE_REQUIRE_CP_PAYLOAD_MISSING = 0x364C
  IPSEC_KEY_MODULE_IMPERSONATION_NEGOTIATION_PENDING = 0x364D
  IPSEC_IKE_COEXISTENCE_SUPPRESS = 0x364E
  IPSEC_IKE_RATELIMIT_DROP = 0x364F
  IPSEC_IKE_PEER_DOESNT_SUPPORT_MOBIKE = 0x3650
  IPSEC_IKE_AUTHORIZATION_FAILURE = 0x3651
  IPSEC_IKE_STRONG_CRED_AUTHORIZATION_FAILURE = 0x3652
  IPSEC_IKE_AUTHORIZATION_FAILURE_WITH_OPTIONAL_RETRY = 0x3653
  IPSEC_IKE_STRONG_CRED_AUTHORIZATION_AND_CERTMAP_FAILURE = 0x3654
  IPSEC_BAD_SPI = 0x3656
  IPSEC_SA_LIFETIME_EXPIRED = 0x3657
  IPSEC_WRONG_SA = 0x3658
  IPSEC_REPLAY_CHECK_FAILED = 0x3659
  IPSEC_INVALID_PACKET = 0x365A
  IPSEC_INTEGRITY_CHECK_FAILED = 0x365B
  IPSEC_CLEAR_TEXT_DROP = 0x365C
  IPSEC_AUTH_FIREWALL_DROP = 0x365D
  IPSEC_THROTTLE_DROP = 0x365E
  IPSEC_DOSP_BLOCK = 0x3665
  IPSEC_DOSP_RECEIVED_MULTICAST = 0x3666
  IPSEC_DOSP_INVALID_PACKET = 0x3667
  IPSEC_DOSP_STATE_LOOKUP_FAILED = 0x3668
  IPSEC_DOSP_MAX_ENTRIES = 0x3669
  IPSEC_DOSP_KEYMOD_NOT_ALLOWED = 0x366A
  IPSEC_DOSP_NOT_INSTALLED = 0x366B
  IPSEC_DOSP_MAX_PER_IP_RATELIMIT_QUEUES = 0x366C
  SXS_SECTION_NOT_FOUND = 0x36B0
  SXS_CANT_GEN_ACTCTX = 0x36B1
  SXS_INVALID_ACTCTXDATA_FORMAT = 0x36B2
  SXS_ASSEMBLY_NOT_FOUND = 0x36B3
  SXS_MANIFEST_FORMAT_ERROR = 0x36B4
  SXS_MANIFEST_PARSE_ERROR = 0x36B5
  SXS_ACTIVATION_CONTEXT_DISABLED = 0x36B6
  SXS_KEY_NOT_FOUND = 0x36B7
  SXS_VERSION_CONFLICT = 0x36B8
  SXS_WRONG_SECTION_TYPE = 0x36B9
  SXS_THREAD_QUERIES_DISABLED = 0x36BA
  SXS_PROCESS_DEFAULT_ALREADY_SET = 0x36BB
  SXS_UNKNOWN_ENCODING_GROUP = 0x36BC
  SXS_UNKNOWN_ENCODING = 0x36BD
  SXS_INVALID_XML_NAMESPACE_URI = 0x36BE
  SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED = 0x36BF
  SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED = 0x36C0
  SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE = 0x36C1
  SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE = 0x36C2
  SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE = 0x36C3
  SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT = 0x36C4
  SXS_DUPLICATE_DLL_NAME = 0x36C5
  SXS_DUPLICATE_WINDOWCLASS_NAME = 0x36C6
  SXS_DUPLICATE_CLSID = 0x36C7
  SXS_DUPLICATE_IID = 0x36C8
  SXS_DUPLICATE_TLBID = 0x36C9
  SXS_DUPLICATE_PROGID = 0x36CA
  SXS_DUPLICATE_ASSEMBLY_NAME = 0x36CB
  SXS_FILE_HASH_MISMATCH = 0x36CC
  SXS_POLICY_PARSE_ERROR = 0x36CD
  SXS_XML_E_MISSINGQUOTE = 0x36CE
  SXS_XML_E_COMMENTSYNTAX = 0x36CF
  SXS_XML_E_BADSTARTNAMECHAR = 0x36D0
  SXS_XML_E_BADNAMECHAR = 0x36D1
  SXS_XML_E_BADCHARINSTRING = 0x36D2
  SXS_XML_E_XMLDECLSYNTAX = 0x36D3
  SXS_XML_E_BADCHARDATA = 0x36D4
  SXS_XML_E_MISSINGWHITESPACE = 0x36D5
  SXS_XML_E_EXPECTINGTAGEND = 0x36D6
  SXS_XML_E_MISSINGSEMICOLON = 0x36D7
  SXS_XML_E_UNBALANCEDPAREN = 0x36D8
  SXS_XML_E_INTERNALERROR = 0x36D9
  SXS_XML_E_UNEXPECTED_WHITESPACE = 0x36DA
  SXS_XML_E_INCOMPLETE_ENCODING = 0x36DB
  SXS_XML_E_MISSING_PAREN = 0x36DC
  SXS_XML_E_EXPECTINGCLOSEQUOTE = 0x36DD
  SXS_XML_E_MULTIPLE_COLONS = 0x36DE
  SXS_XML_E_INVALID_DECIMAL = 0x36DF
  SXS_XML_E_INVALID_HEXIDECIMAL = 0x36E0
  SXS_XML_E_INVALID_UNICODE = 0x36E1
  SXS_XML_E_WHITESPACEORQUESTIONMARK = 0x36E2
  SXS_XML_E_UNEXPECTEDENDTAG = 0x36E3
  SXS_XML_E_UNCLOSEDTAG = 0x36E4
  SXS_XML_E_DUPLICATEATTRIBUTE = 0x36E5
  SXS_XML_E_MULTIPLEROOTS = 0x36E6
  SXS_XML_E_INVALIDATROOTLEVEL = 0x36E7
  SXS_XML_E_BADXMLDECL = 0x36E8
  SXS_XML_E_MISSINGROOT = 0x36E9
  SXS_XML_E_UNEXPECTEDEOF = 0x36EA
  SXS_XML_E_BADPEREFINSUBSET = 0x36EB
  SXS_XML_E_UNCLOSEDSTARTTAG = 0x36EC
  SXS_XML_E_UNCLOSEDENDTAG = 0x36ED
  SXS_XML_E_UNCLOSEDSTRING = 0x36EE
  SXS_XML_E_UNCLOSEDCOMMENT = 0x36EF
  SXS_XML_E_UNCLOSEDDECL = 0x36F0
  SXS_XML_E_UNCLOSEDCDATA = 0x36F1
  SXS_XML_E_RESERVEDNAMESPACE = 0x36F2
  SXS_XML_E_INVALIDENCODING = 0x36F3
  SXS_XML_E_INVALIDSWITCH = 0x36F4
  SXS_XML_E_BADXMLCASE = 0x36F5
  SXS_XML_E_INVALID_STANDALONE = 0x36F6
  SXS_XML_E_UNEXPECTED_STANDALONE = 0x36F7
  SXS_XML_E_INVALID_VERSION = 0x36F8
  SXS_XML_E_MISSINGEQUALS = 0x36F9
  SXS_PROTECTION_RECOVERY_FAILED = 0x36FA
  SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT = 0x36FB
  SXS_PROTECTION_CATALOG_NOT_VALID = 0x36FC
  SXS_UNTRANSLATABLE_HRESULT = 0x36FD
  SXS_PROTECTION_CATALOG_FILE_MISSING = 0x36FE
  SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE = 0x36FF
  SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME = 0x3700
  SXS_ASSEMBLY_MISSING = 0x3701
  SXS_CORRUPT_ACTIVATION_STACK = 0x3702
  SXS_CORRUPTION = 0x3703
  SXS_EARLY_DEACTIVATION = 0x3704
  SXS_INVALID_DEACTIVATION = 0x3705
  SXS_MULTIPLE_DEACTIVATION = 0x3706
  SXS_PROCESS_TERMINATION_REQUESTED = 0x3707
  SXS_RELEASE_ACTIVATION_CONTEXT = 0x3708
  SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY = 0x3709
  SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE = 0x370A
  SXS_INVALID_IDENTITY_ATTRIBUTE_NAME = 0x370B
  SXS_IDENTITY_DUPLICATE_ATTRIBUTE = 0x370C
  SXS_IDENTITY_PARSE_ERROR = 0x370D
  MALFORMED_SUBSTITUTION_STRING = 0x370E
  SXS_INCORRECT_PUBLIC_KEY_TOKEN = 0x370F
  UNMAPPED_SUBSTITUTION_STRING = 0x3710
  SXS_ASSEMBLY_NOT_LOCKED = 0x3711
  SXS_COMPONENT_STORE_CORRUPT = 0x3712
  ADVANCED_INSTALLER_FAILED = 0x3713
  XML_ENCODING_MISMATCH = 0x3714
  SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT = 0x3715
  SXS_IDENTITIES_DIFFERENT = 0x3716
  SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT = 0x3717
  SXS_FILE_NOT_PART_OF_ASSEMBLY = 0x3718
  SXS_MANIFEST_TOO_BIG = 0x3719
  SXS_SETTING_NOT_REGISTERED = 0x371A
  SXS_TRANSACTION_CLOSURE_INCOMPLETE = 0x371B
  SMI_PRIMITIVE_INSTALLER_FAILED = 0x371C
  GENERIC_COMMAND_FAILED = 0x371D
  SXS_FILE_HASH_MISSING = 0x371E
  EVT_INVALID_CHANNEL_PATH = 0x3A98
  EVT_INVALID_QUERY = 0x3A99
  EVT_PUBLISHER_METADATA_NOT_FOUND = 0x3A9A
  EVT_EVENT_TEMPLATE_NOT_FOUND = 0x3A9B
  EVT_INVALID_PUBLISHER_NAME = 0x3A9C
  EVT_INVALID_EVENT_DATA = 0x3A9D
  EVT_CHANNEL_NOT_FOUND = 0x3A9F
  EVT_MALFORMED_XML_TEXT = 0x3AA0
  EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL = 0x3AA1
  EVT_CONFIGURATION_ERROR = 0x3AA2
  EVT_QUERY_RESULT_STALE = 0x3AA3
  EVT_QUERY_RESULT_INVALID_POSITION = 0x3AA4
  EVT_NON_VALIDATING_MSXML = 0x3AA5
  EVT_FILTER_ALREADYSCOPED = 0x3AA6
  EVT_FILTER_NOTELTSET = 0x3AA7
  EVT_FILTER_INVARG = 0x3AA8
  EVT_FILTER_INVTEST = 0x3AA9
  EVT_FILTER_INVTYPE = 0x3AAA
  EVT_FILTER_PARSEERR = 0x3AAB
  EVT_FILTER_UNSUPPORTEDOP = 0x3AAC
  EVT_FILTER_UNEXPECTEDTOKEN = 0x3AAD
  EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL = 0x3AAE
  EVT_INVALID_CHANNEL_PROPERTY_VALUE = 0x3AAF
  EVT_INVALID_PUBLISHER_PROPERTY_VALUE = 0x3AB0
  EVT_CHANNEL_CANNOT_ACTIVATE = 0x3AB1
  EVT_FILTER_TOO_COMPLEX = 0x3AB2
  EVT_MESSAGE_NOT_FOUND = 0x3AB3
  EVT_MESSAGE_ID_NOT_FOUND = 0x3AB4
  EVT_UNRESOLVED_VALUE_INSERT = 0x3AB5
  EVT_UNRESOLVED_PARAMETER_INSERT = 0x3AB6
  EVT_MAX_INSERTS_REACHED = 0x3AB7
  EVT_EVENT_DEFINITION_NOT_FOUND = 0x3AB8
  EVT_MESSAGE_LOCALE_NOT_FOUND = 0x3AB9
  EVT_VERSION_TOO_OLD = 0x3ABA
  EVT_VERSION_TOO_NEW = 0x3ABB
  EVT_CANNOT_OPEN_CHANNEL_OF_QUERY = 0x3ABC
  EVT_PUBLISHER_DISABLED = 0x3ABD
  EVT_FILTER_OUT_OF_RANGE = 0x3ABE
  EC_SUBSCRIPTION_CANNOT_ACTIVATE = 0x3AE8
  EC_LOG_DISABLED = 0x3AE9
  EC_CIRCULAR_FORWARDING = 0x3AEA
  EC_CREDSTORE_FULL = 0x3AEB
  EC_CRED_NOT_FOUND = 0x3AEC
  EC_NO_ACTIVE_CHANNEL = 0x3AED
  MUI_FILE_NOT_FOUND = 0x3AFC
  MUI_INVALID_FILE = 0x3AFD
  MUI_INVALID_RC_CONFIG = 0x3AFE
  MUI_INVALID_LOCALE_NAME = 0x3AFF
  MUI_INVALID_ULTIMATEFALLBACK_NAME = 0x3B00
  MUI_FILE_NOT_LOADED = 0x3B01
  RESOURCE_ENUM_USER_STOP = 0x3B02
  MUI_INTLSETTINGS_UILANG_NOT_INSTALLED = 0x3B03
  MUI_INTLSETTINGS_INVALID_LOCALE_NAME = 0x3B04
  MCA_INVALID_CAPABILITIES_STRING = 0x3B60
  MCA_INVALID_VCP_VERSION = 0x3B61
  MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION = 0x3B62
  MCA_MCCS_VERSION_MISMATCH = 0x3B63
  MCA_UNSUPPORTED_MCCS_VERSION = 0x3B64
  MCA_INTERNAL_ERROR = 0x3B65
  MCA_INVALID_TECHNOLOGY_TYPE_RETURNED = 0x3B66
  MCA_UNSUPPORTED_COLOR_TEMPERATURE = 0x3B67
  AMBIGUOUS_SYSTEM_DEVICE = 0x3B92
  SYSTEM_DEVICE_NOT_FOUND = 0x3BC3
  HASH_NOT_SUPPORTED = 0x3BC4
  HASH_NOT_PRESENT = 0x3BC5
  INVALID_HANDLE_VALUE = 0xffffffff
end
